/var
{
	classlist = list("Alchemist", "Assassin", "Barbarian", "Blacksmith", "Bounty Hunter", "Crusader", "Dwarf", "Engineer", "Elementalist", "Ghost", "Knight", "Magician", "Merchant", "Monk", "Ninja", "Priest", "Ranger", "Scholar", "Scout", "Seer", "Soldier", "Sprite", "Surgeon", "Swashbuckler", "Thief", "Thug", "Wisp", "Wizard", "Zombie");
	desclist = list();
}

/proc/ClassDescs()
{
	desclist["Alchemist"] = "The Alchemist is a skilled chemist, capable of distilling strange and exotic potions. He has a low Attack score but high Lore, and has the ability to take any two potions in his inventory and mix them to produce a third potion of his choice.";
	desclist["Assassin"] = "The Assassin is an expertly skilled killer. In open combat his fighting ability leaves something to be desired, but any time he rolls doubles on his combat roll, he scores double the attack total.";
	desclist["Barbarian"] = "The Barbarian is a fierce nomadic warrior. His combat skills are second to none, but due to his proud, savage ways he is not allowed to flee combat voluntarily."
	desclist["Bounty Hunter"] = "The Bounty Hunter is a soldier of fortune. He has an agreement with his employer whereby he gets an extra 10 points for every monster he kills.";
	desclist["Blacksmith"] = "The Blacksmith is an honest, hard-working craftsman. Although built tough from long hours at the forge, his combat skills are mediocre and he is poorly learned, but he can use his skills to keep his equipment from breaking under the strain of adventuring.";

	desclist["Crusader"] = "The Crusader is a zealous religious warrior. He is a skilled combatant, and his holy fervor gives him a +1 bonus when fighting the evil hordes of Undead.";
	desclist["Dwarf"] = "The Dwarf is a stout, hardy warrior from the mountains. His small stature may not be built for combat, but his sheer strength and tenaciousness allows him to ignore the first point of damage each combat round.";
	desclist["Elementalist"] = "The Elementalist is a powerful spellcaster, with all the raw power of the elements at his disposal. He may conjure forth each of the four elements once per game, adding 7 to his attack bonus in one round of combat.";
	desclist["Engineer"] = "A skilled builder, the Engineer is an master at his art. He can use his knowledge of architecture and mechanics to spot and avoid traps.";
	desclist["Ghost"] = "The Ghost is a haunting undead apparation. Weak and easily dissipated, the Ghost has the impressive ability of phasing through walls.";

	desclist["Knight"] = "The Knight is a virtuous soldier who roams the land doing good deeds. He is an excellent fighter and is assisted even further by his trusty Squire, but his strict code of chivalric honor prevents him from attacking other players.";
	desclist["Magician"] = "The Magician is a talented wielder of the chaotic, unpredictable forces of magic. In combat, he may attempt to conjure forth a powerful magical blast, with a 2/3 chance that increases with Lore; if he succeeds, he adds +4 to his roll, but if he fails, he subtracts 1.";
	desclist["Merchant"] = "The Merchant is a daring entrepreneur and master salesman. His survival skills are lacking, but he gets a 20% bonus to his score.";
	desclist["Monk"] = "The Monk is a humble, devout soul who prefers to spend his days in study and prayer. Though meek, he possesses a keen sense of discipline--if alone in a room, he may spend his turn Meditating to regain 1 health, but may perform no other actions that turn. Unfortunately, due to the strict vows of his order he is not allowed to wield any weapons.";
	desclist["Ninja"] = "The Ninja is a stealthy and secretive assassin. He has the special ability to sneak through rooms occupied by monsters, although he cannot be accompanied by any companions--the Ninja walks alone.";

	desclist["Priest"] = "The Priest is a wizened old cleric, well-versed in religious lore. Although he abhors violence and is a terrible fighter, his force of faith can prevent the undead from attacking him and destroy such demonic horrors at a word.";
	desclist["Ranger"] = "The Ranger is a skilled outdoorsman and survivalist. Learned and moderately skilled in combat, his well-honed survival instincts allow him to flee from combat in a direction of his choice, rather than randomly, and cannot be ambushed by wandering monsters due to his alertness.";
	desclist["Scholar"] = "The Scholar is a well-learned professor of arcane lore. Feeble and slight of build, and possessing no innate magical abilities, his strength lies in his immense knowledge of magical relics which allow him to use magic items without any risk of automatic failure.";
	desclist["Scout"] = "The Scout is a fast and agile lookout. Not much in a fight, his ability to survey one adjacent room per turn and see its contents is immeasurably valuable.";
	desclist["Seer"] = "The Seer is a powerful medium who possesses extraordinary powers of perception. The Seer can always detect the presence of living creatures in surrounding rooms, wherever he goes.";

	desclist["Soldier"] = "The Soldier is a battle-hardened veteran. In addition to formidable combat prowess, he starts his quest with Sword and Shield in hand.";
	desclist["Sprite"] = "The Sprite is a tiny, nimble magical creature. Although incredibly weak due to his small stature, the Sprite's extreme agility and evasive skill restricts attackers to only rolling one die against the Sprite. Unfortunately, the Sprite must score a whopping 8 extra points to inflict additional wounds and is too small to wear any armor or carry a shield.";
	desclist["Surgeon"] = "The Surgeon is a skilled medic and physician. His medical skills allow him a chance to keep wounded companions alive and lets him counter poison with handy antitoxin.";
	desclist["Swashbuckler"] = "The Swashbuckler is a daring and bold swordsman. An expert fencer, the Swashbuckler gains a +1 in combat whenever wielding a sword, and has the ambidextrous ability to wield two weapons at once. His extreme daring and bravado can cause him to score incredibly high rolls if he's lucky, but may also backfire if he rolls poorly.";
	desclist["Thief"] = "The Thief is a stealthy pickpocket and rogue. He has the ability to pick up treasure in a room even if it's being guarded by a monster.";

	desclist["Thug"] = "The Thug is a huge powerful brute who likes to solve problems through sheer brawn. Not only does he possess great strength, his skills at bullying can be used to intimidate monsters and even players who have a lower Attack score than him, preventing them from attacking.";
	desclist["Wisp"] = "This bizarre, twinkling life-form blinks in and out of existence and across space and time at will. The Wisp may at any time pay 1 life to teleport to a random location on the same level.";
	desclist["Wizard"] = "The Wizard is a powerful sorceror who can channel his life-force into pure, deadly energy. During combat, he may use his Channeling skill to spend one point of health for an attack bonus equal to his Lore.";
	desclist["Zombie"] = "The Zombie is a terrifying undead abomination. He has a very high Life score which he can increase by defeating living opponents, but as a creature of undead he is subject to certain weaknesses, and NPCs won't have anything to do with him..";
}

/mob/player
{
	proc/SelectClass()
	{
		var/class;
		while (class == null)
		{
			class = input(src, "What class would you like to play as?", "Select Class") in classlist;
			if (alert(src, desclist[class] + " Are you sure you want this class?", "Confirm Selection", "Yes", "No") == "No") class = null;
		}

		var/mob/player/N;

		switch (class)
		{
			if ("Alchemist") N = new/mob/player/alchemist;
			if ("Assassin") N = new/mob/player/assassin;
			if ("Barbarian") N = new/mob/player/barbarian;
			if ("Blacksmith") N = new/mob/player/blacksmith;
			if ("Bounty Hunter") N = new/mob/player/bounty_hunter;
			if ("Crusader") N = new/mob/player/crusader;
			if ("Dwarf") N = new/mob/player/dwarf;
			if ("Elementalist") N = new/mob/player/elementalist;
			if ("Engineer") N = new/mob/player/engineer;
			if ("Ghost") N = new/mob/player/ghost;
			if ("Knight") N = new/mob/player/knight;
			if ("Magician") N = new/mob/player/magician;
			if ("Merchant") N = new/mob/player/merchant;
			if ("Monk") N = new/mob/player/monk;
			if ("Ninja") N = new/mob/player/ninja;
			if ("Priest") N = new/mob/player/priest;
			if ("Ranger") N = new/mob/player/ranger;
			if ("Scholar") N = new/mob/player/scholar;
			if ("Scout") N = new/mob/player/scout;
			if ("Seer") N = new/mob/player/seer;
			if ("Soldier") N = new/mob/player/soldier;
			if ("Sprite") N = new/mob/player/sprite;
			if ("Surgeon") N = new/mob/player/surgeon;
			if ("Swashbuckler") N = new/mob/player/swashbuckler;
			if ("Thief") N = new/mob/player/thief;
			if ("Thug") N = new/mob/player/thug;
			if ("Wisp") N = new/mob/player/wisp;
			if ("Wizard") N = new/mob/player/wizard;
			if ("Zombie") N = new/mob/player/zombie;
		}

		src.ChooseColor();

		while (N.loc == null)
		{
			N.loc = locate("entrance" + num2text(rand(1,9)));
		}

		N.gender = src.client.gender;
		N.key = src.key;
		N.class = class;
		N.name = N.key + " the [class]";
		N.curlife = N.life;
		N.color = src.color;
		N.frame = image('pframe.dmi', N, colorlist[N.color]);

		players << "<font color=[fontlist[N.color]]><b>[N]</b></font> has entered the dungeon!"

		for (var/mob/P in players)
		{
			if (P != N)
			{
				P.frames["[N]"] = N.frame;
				P << P.frames["[N]"];
			}
		}

		N.loc.contents - N << "[N] enters the room.";
		N.loc:RevealAll();

		N.cmap["7,8,3"] = image('troom.dmi', locate(7,8,3), layer=AREA_LAYER + 1);
		N << N.cmap["7,8,3"];
		N << N.frame;

		del(src);
	}

	alchemist
	{
		icon = 'chemist.dmi';
		attack = 1;
		charisma = 4;
		lore = 4;
		life = 12;

		verb
		{
			mix(obj/item/p1 as obj in usr, obj/item/p2 as obj in usr, result in potionlist)
			{
				if (p1.item_type != "potion" || p2.item_type != "potion")
				{
					usr << "Brilliant, Einstein. Try mixing <i>potions</i> next time.";
					return;
				}
				if (p1 == p2)
				{
					usr << "Unfortunately, despite all your knowledge of chemistry, you can't mix two identical liquids and make anything useful of it.";
					return;
				}

				usr.score -= (p1.worth + p2.worth);

				var/ptype = potionlist[result];
				var/obj/item/p3 = new ptype(usr);
				usr.score += p3.worth;

				usr.loc.contents - usr << "[usr] carefully mixes two potions together.";
				usr << "You pour [p1] and [p2] together, sprinkling a few reagents into the mixture. You watch, satisfied, as the bubbling concotion settles into \a [p3].";

				del(p1);
				del(p2);
			}
		}
	}

	assassin
	{
		icon = 'assassin.dmi';
		attack = 2;
		lore = 2;
		life = 13;
		charisma = 3;
	}

	barbarian
	{
		icon = 'barbarian.dmi';
		attack = 4;
		lore = 1;
		life = 16;
		charisma = 3;

		Flee()
		{
			usr << "A proud Barbarian never flees!";
		}
	}

	blacksmith
	{
		icon = 'blacksmith.dmi';
		attack = 2;
		lore = 1;
		life = 15;
		charisma = 3;
	}

	bounty_hunter
	{
		icon = 'bounty.dmi';
		attack = 2;
		lore = 1;
		life = 14;
		charisma = 4;
	}

	crusader
	{
		icon = 'crusader.dmi';
		attack = 3;
		lore = 1;
		life = 15;
		charisma = 3;
	}

	dwarf
	{
		icon = 'dwarf.dmi';
		attack = 2;
		lore = 1;
		life = 15;
		charisma = 3;

		defend = 1;
		defense = "shrugs off";
		nat_defense = "shrugs off";
	}

	elementalist
	{
		icon = 'elementalist.dmi';
		attack = 1;
		lore = 4;
		life = 11;
		charisma = 4;

		var/elements[] = list("Fire", "Wind", "Water", "Earth", "Cancel");
		var/summon_turn;

		verb
		{
			summon(element in src.elements)
			{
				if (src.summon_turn >= turn)
				{
					usr << "You've already summoned this turn!";
					return;
				}
				else if (element == "Cancel" && src.elements.len > 1)
				{
					return;
				}
				else if (usr.weapon && usr.weapon.type == /obj/item/legendary/wizard_staff && usr.weapon.Magic_Use(usr))
				{
					usr << "You feel power flowing into you from the Staff of Wizardry...";
					element = pick("Fire", "Wind", "Water", "Earth");
				}
				else if (src.elements.len == 1)
				{
					usr << "You've already spent all your summoning powers!";
					return;
				}

				switch (element)
				{
					if ("Fire") usr.loc.contents << "<font color=#FF9000>[usr] conjures forth a searing inferno of scorching elemental fire!</font>";
					if ("Wind") usr.loc.contents << "<font color=#80C0FF>Lightning crackles through the air as [usr] summons a raging storm, buffeting the area with heavy winds!!</font>";
					if ("Water") usr.loc.contents << "<font color=#0060C0>[usr] calls forth the raw fury of the oceans, flooding the room in a massive tidal wave!</font>";
					if ("Earth") usr.loc.contents << "<font color=#807020>The walls heave and buckle as [usr] calls on the ferocious power of the earth, rocking the room with sheer power!</font>";
				}

				src.elements.Remove(element);
				src.summon_turn = turn;

				usr.adds += 8;
			}
		}
	}

	engineer
	{
		icon = 'engineer.dmi';
		attack = 2;
		lore = 2;
		life = 12;
		charisma = 3;
	}

	ghost
	{
		icon = 'ghost.dmi';
		attack = 1;
		lore = 2;
		life = 9;
		charisma = 2;

		density = 0;
		undead = 1;
	}

	knight
	{
		icon = 'knight.dmi';
		attack = 3;
		lore = 2;
		life = 15;
		charisma = 4;

		Attack(mob/M)
		{
			usr << "Your strict code of chivalric honor prevents you from fighting except in self-defense!";
			return;
		}

		New()
		{
			var/mob/companion/squire = new/mob/companion/common/squire();
			squire.loc = src;
			src.companions.Add(squire);

			..();
		}
	}

	magician
	{
		icon = 'magician.dmi';
		attack = 1;
		lore = 4;
		life = 11;
		charisma = 3;

		var/cast_turn;

		verb
		{
			cast()
			{
				if (!usr.combat)
				{
					usr << "You don't have any opponents to cast on!";
					return;
				}
				else if (src.cast_turn >= turn)
				{
					usr << "You've already cast this turn!";
					return;
				}

				switch(rand(1,5))
				{
					if (1) usr.loc.contents << "[usr] says, \"Hocus pocus!\"";
					if (2) usr.loc.contents << "[usr] says, \"Presto!\"";
					if (3) usr.loc.contents << "[usr] says, \"Alakazam!\"";
					if (4) usr.loc.contents << "[usr] says, \"Abra cadabra!\"";
					if (5) usr.loc.contents << "[usr] says, \"Poof!\"";
				}

				if (usr.weapon && usr.weapon.type == /obj/item/legendary/wizard_staff && usr.weapon.Magic_Use(usr))
				{
					usr << "You feel power flowing into you from the Staff of Wizardry...";
					usr.loc.contents << "<font color=#C0C000>With an impressive puff of smoke, [usr] conjures forth a powerful fireball!</font>";
					usr.adds += 4;
				}
				else if (rand(1, (usr.lore + usr.lore_adds) - 1) != 1)
				{
					usr.loc.contents << "<font color=#C0C000>With an impressive puff of smoke, [usr] conjures forth a powerful fireball!</font>";
					usr.adds += 3;
				}
				else
				{
					usr.loc.contents << "<font color=#808080>[usr]'s spell fizzles with a disappointing puff!</font>";
					usr.adds -= 1;
				}

				src.cast_turn = turn;
			}
		}
	}

	merchant
	{
		icon = 'merchant.dmi';
		attack = 1;
		lore = 2;
		life = 11;
		charisma = 5;
	}

	monk
	{
		icon = 'monk.dmi';
		attack = 1;
		lore = 3;
		life = 14;
		charisma = 4;

		var/med_turn;

		verb
		{
			meditate()
			{
				if (src.med_turn >= turn)
				{
					usr << "You're already meditating!";
					return;
				}

				for (var/mob/M in usr.loc)
				{
					if (M && M != usr && istype(M))
					{
						usr << "You can only meditate in perfect solitude.";
						return;
					}
				}

				usr.curlife = min(usr.curlife + 1, usr.life);
				usr.move = null;
				usr << "<font color=#504070>You sit and fall into a deep state of utter peace.</font>";
				src.med_turn = turn;
			}
		}
	}

	ninja
	{
		icon = 'ninja.dmi';
		attack = 2;
		lore = 2;
		life = 11;
		charisma = 1;
	}

	priest
	{
		icon = 'priest.dmi';
		attack = 1;
		lore = 3;
		life = 10;
		charisma = 4;
	}

	ranger
	{
		icon = 'ranger.dmi';
		attack = 2;
		lore = 3;
		life = 14;
		charisma = 3;

		Flee()
		{
			if (usr.loc:exits == 0)
			{
				usr << "Oh no, you're trapped!";
				return;
			}
			usr.move = null;
			while (!usr.move)
			{
				var/dir = input("Flee in which direction?") in list("North", "East", "South", "West");
				switch (dir)
				{
					if ("North") dir = NORTH;
					if ("South") dir = SOUTH;
					if ("East") dir = EAST;
					if ("West") dir = WEST;
				}
				usr.move = get_step(usr.loc, dir);
				if (!usr.move.Enter(usr))
					usr.move = null;
			}

			usr.flee = 1;
		}
	}

	scholar
	{
		icon = 'scholar.dmi';
		attack = 1;
		lore = 4;
		life = 10;
		charisma = 4;
	}

	scout
	{
		icon = 'scout.dmi';
		attack = 1;
		lore = 2;
		life = 13;
		charisma = 4;

		var/survey_turn;

		verb
		{
			survey(dir in list("north", "east", "south", "west"))
			{
				if (src.survey_turn >= turn)
				{
					usr << "You've already surveyed this turn!";
					return;
				}

				var/check;
				switch (dir)
				{
					if ("north") check = 1;
					if ("south") check = 2;
					if ("east") check = 4;
					if ("west") check = 8;
				}

				if (!check) return;

				var/turf/T = get_step(usr.loc, check);

				if (T.Enter(usr))
				{
					usr << "<font color=#9890A0>You turn your gaze [dir]ward...</font>";
					T.Reveal(usr);
					src.survey_turn = turn;
				}
				else
					usr << "Scouts may have eagle eyes, but they don't have x-ray vision--try looking into an open room instead.";
			}
		}
	}

	seer
	{
		icon = 'seer.dmi';
		attack = 1;
		lore = 3;
		life = 12;
		charisma = 4;

		verb
		{
			sixth_sense()
			{
				var/bodycount;
				var/dirname;
				var/found = 0;
				for (var/dir in dirlist)
				{
					var/turf/check = get_step(usr.loc, dir);
					bodycount = 0;

					if (!check) continue;

					for (var/atom/A in check.contents)
					{
						if (ismob(A) && A:undead == 0)
							bodycount++;
					}

					if (bodycount > 0)
					{
						found = 1;

						switch(dir)
						{
							if (1) dirname = "north";
							if (2) dirname = "south";
							if (4) dirname = "east";
							if (8) dirname = "west";
						}

						usr << "<font color=#900050>You sense [bodycount] life form\s to the [dirname].</font>";
					}
				}

				if (found == 0)
					usr << "<font color=#500090>You search the surrounding rooms with your mind, but feel no life force there.</font>";
			}
		}
	}

	soldier
	{
		icon = 'soldier.dmi';
		attack = 3;
		lore = 1;
		life = 14;
		charisma = 3;

		New()
		{
			var/obj/item/sword = new/obj/item/unusual/sword(src);
			var/obj/item/shield = new/obj/item/unusual/shield(src);

			sword.worth = 0;
			shield.worth = 0;

			..();
		}
	}

	sprite
	{
		icon = 'sprite.dmi';
		attack = 1;
		lore = 3;
		life = 7;
		charisma = 4;
	}

	surgeon
	{
		icon = 'doctor.dmi';
		attack = 1;
		lore = 4;
		life = 12;
		charisma = 4;
	}

	swashbuckler
	{
		icon = 'swashbuckler.dmi';
		attack = 2;
		lore = 2;
		life = 13;
		charisma = 3;

		var/obj/item/offhand;
	}

	thief
	{
		icon = 'thief.dmi';
		attack = 1;
		lore = 2;
		life = 12;
		charisma = 3;
	}

	thug
	{
		icon = 'thug.dmi';
		attack = 3;
		lore = 1;
		life = 14;
		charisma = 2;
	}

	wisp
	{
		icon = 'wisp.dmi';
		attack = 1;
		lore = 4;
		life = 11;
		charisma = 3;

		verb
		{
			teleport()
			{
				if (usr.curlife < 2)
				{
					usr << "You don't have enough health to teleport!";
					return;
				}

				usr.loc.contents - usr << "<font color=#00C0C0>[usr] suddenly blinks out of existence!</font>";
				usr.loc:RevealAll();

				usr.x = rand(1, world.maxx);
				usr.y = rand(1, world.maxy);

				usr.loc.contents - usr << "<font color=#409090>[usr] spontaneously materializes in the room!</font>";
				usr.loc:RevealAll();
				usr.loc:Reveal(usr);

				if (usr.combat)
				{
					if (usr.opponent && usr.opponent.opponent)
						usr.opponent.opponent = null;
					usr.opponent = null;
					combats.Remove(usr.combat);
					del (usr.combat);
				}

				usr.curlife--;
			}
		}
	}

	wizard
	{
		icon = 'wizard.dmi';
		attack = 1;
		lore = 4;
		life = 10;
		charisma = 3;

		var/cast_turn;

		verb
		{
			channel()
			{
				if (!usr.combat)
				{
					usr << "You don't have any opponents to channel your energies upon!";
					return;
				}
				else if (src.cast_turn >= turn)
				{
					usr << "You've already channeled this turn!";
					return;
				}
				else if (usr.curlife < 2)
				{
					usr << "You don't have enough health to channel!";
					return;
				}

				usr.loc.contents << "<font color=#9060C0>The air crackles with magical energies as [usr] draws upon his mana for a terrific blow!</font>";

				usr.adds += (usr.lore + usr.lore_adds);

				if (usr.weapon && usr.weapon.type == /obj/item/legendary/wizard_staff && usr.weapon.Magic_Use(usr))
					usr << "You feel power flowing into you from the Staff of Wizardry...";
				else
					usr.curlife--;

				src.cast_turn = turn;
			}
		}
	}

	zombie
	{
		icon = 'zombie.dmi';
		attack = 3;
		lore = 1;
		life = 22;
		charisma = 0;

		undead = 1;
	}
}

/mob/player/Stat()
{
	if (src.type != /mob/player)
	{
		if (statpanel(src.name))
		{
			stat("Turn: [turn]");
			stat("");
			stat("Health: [src.curlife]/[src.life]");
			stat("Attack: [src.attack]");
			stat("Lore: [src.lore]");
			stat("Charisma: [src.charisma]");
			stat("");
			stat("Score: [src.score]");
		}

		if (statpanel("Inventory"))
		{
			var/statlist[] = list();
			statlist.Add(src.contents);
			statlist.Remove(src.companions);
			stat(statlist);
		}
		if (statpanel("Companions"))
		{
			stat(src.companions);
		}
	}
}