/combat
{
	var
	{
		sides[] = list();
		turf/turf;
	}

	Del()
	{
		if (src.turf.combat == src)
		{
			var/i;
			for (i=1, i<=combats.len, i++)
			{
				var/combat/C = combats[i];
				if (C.turf == src.turf)
					break;
			}

			if (i == combats.len + 1)
				src.turf.combat = null;
			else
				src.turf.combat = combats[i];
		}
		combats.Remove(src);

		for (var/mob/S in src.sides)
		{
			S.opponent = null;
			S.combat = null;
		}


		..();
	}

	New()
	{
		combats.Add(src);

		..();
	}

	proc
	{
		CalcAdds(mob/M, mob/N, roll1, roll2)
		{
			if ((M.weapon && M.class != "Blacksmith" && rand(1,100) > M.weapon.durability && M.weapon.broken != 1) || (M.weapon && M.weapon.broken != 1 && N.type == /mob/monster/legendary/rot_fiend && M.weapon.durability != 100))
			{
				var/save = 0;
				if (M.companions)
				{
					for (var/mob/companion/C in M.companions)
					{
						if (C.type == /mob/companion/unusual/blacksmith)
							save = 1;
					}
				}

				if (N.type == /mob/monster/legendary/rot_fiend)
					M << "<FONT COLOR=#00A000>The rot fiend's foul touch corrodes your [M.weapon.name]!</font>";

				if (save == 0)
				{
					M << "<font color=#A0A0A0>Your weapon breaks!</font>";
					M.weapon.TakeAdds();
					M.score -= M.weapon.worth;
					M.weapon.attack_adds = 0;
					M.weapon.worth = 0;
					M.weapon.icon_state = "broken " + M.weapon.icon_state;
					M.weapon.broken = 1;
					M.weapon.name = "broken " + M.weapon.name;
					M.weapon.desc = "A broken and useless piece of equipment.";
				}
			}

			if (istype(M, /mob/player/swashbuckler) && ((M:offhand && rand(1,100) > M:offhand.durability && M:offhand.broken != 1) || (M:offhand && M:offhand.broken != 1 && N.type == /mob/monster/legendary/rot_fiend && M:offhand.durability != 100)))
			{
				var/save = 0;
				if (M.companions)
				{
					for (var/mob/companion/C in M.companions)
					{
						if (C.type == /mob/companion/unusual/blacksmith)
							save = 1;
					}
				}

				if (N.type == /mob/monster/legendary/rot_fiend)
					M << "<font color=#00A000>The rot fiend's foul touch corrodes your offhand [M:offhand.name]!</font>";

				if (save == 0)
				{
					M << "<font color=#A0A0A0>Your offhand weapon breaks!</font>";
					M:offhand.TakeAdds();
					M.score -= M:offhand.worth;
					M:offhand.attack_adds = 0;
					M:offhand.worth = 0;
					M:offhand.icon_state = "broken " + M:offhand.icon_state;
					M:offhand.broken = 1;
					M:offhand.name = "broken " + M:offhand.name;
					M:offhand.desc = "A broken and useless piece of equipment.";
				}
			}

			var/total = M.attack + M.adds;

			if (M.class == "Swashbuckler")
			{
				if (roll1 == 6) total += 2;
				if (roll2 == 6) total += 2;
				if (roll1 == 1) total -= 2;
				if (roll2 == 1) total -= 2;
			}

			if (M.class == "Swashbuckler" && ((M.weapon && M.weapon.item_type == "sword") || (M:offhand && M:offhand.item_type == "sword"))) total++;
			if (M.class == "Dwarf" && M.weapon && M.weapon.item_type == "axe") total++;

			if (M.class == "Crusader" && N.undead) total++;

			if (M.weapon && M.weapon.type == /obj/item/rare/holy_lance && N.undead) total++;
			if (M.weapon && M.weapon.type == /obj/item/legendary/barbed_whip_of_pain && N.undead == 0) total += 2;

			for (var/mob/companion/C in M.companions)
				if (C.rank == 1) total += C.attack;

			if (M.weapon && M.weapon.type == /obj/item/unusual/bow)
			{
				if (M.weapon.loaded == 1)
					M.weapon.loaded = 2;
				else if (M.weapon.loaded == 2)
				{
					M.weapon.loaded = -1;
				}
				else if (M.weapon.loaded == -1)
				{
					M.weapon.loaded = 0;
					total -= 2;
				}
				else
				{
					M.weapon.loaded = 1;
					total -= -2;
				}
			}

			spawn(1)
			{
				if (M) M.adds = 0;
			}
			return total;
		}

		RunCombatRound()
		{
			var
			{
				roll1;
				roll2;
				roll3;
				roll[] = new/list(2);
			}


			if (!(src.sides[1]) || !(src.sides[2]))
			{
				del (src);
				return;
			}

			src.turf.contents - src.sides[2] << "\The [src.sides[1]] attacks [src.sides[2]]!";
			src.sides[2] << "\The [src.sides[1]] attacks you!";


			for (var/i=1, i<=2, i++)
			{
				var/mob/attacker = src.sides[i];
				var/mob/defender = src.sides[3 - i];

				if (!(attacker) || !(defender))
				{
					del (src);
					return;
				}

				if (attacker && attacker.class == "Priest" && defender && defender.undead == 1)
				{
					src.turf.contents << "[attacker] raises \his arms to the heavens, calling forth a holy bolt that smites [defender].";
					defender.Die();

					src.turf.combat = null;
					src.turf.RevealAll();
					attacker.combat = null;
					attacker.opponent = null;
					del(src);
					return;
				}

				if (attacker && istype(attacker, /mob/monster) && rand(1,4) == 1)
				{
					attacker:Special(defender);
				}

				if (!(attacker) || !(defender))
				{
					del (src);
					return;
				}

				if (defender && defender.class != "Sprite")
				{
					roll1 = roll(1, 6);
					roll2 = roll(1, 6);

					if (istype(attacker, /mob/player) && roll1 == 1 && rand(1, 2) == 1) roll1 = roll(1, 6);
					if (istype(attacker, /mob/player) && roll2 == 1 && rand(1, 2) == 1) roll2 = roll(1, 6);

					if (attacker.type == /mob/monster/rare/chimera && attacker.curlife > attacker.life / 2)
						roll3 = roll(1, 6);
					else
						roll3 = 0;

					if (attacker.lucky)
					{
						attacker.lucky--;

						roll1 = rand(5, 6);
						roll2 = rand(5, 6);
					}

					roll[i] = roll1 + roll2 + roll3 + CalcAdds(src.sides[i], src.sides[3 - i], roll1, roll2);
					if (roll3 == 0)
					{
						if (roll1 != roll2)
							src.turf.contents << "<font color=#F00000>\The [src.sides[i]] rolls a [roll1] and a [roll2], plus [CalcAdds(src.sides[i], src.sides[3 - i], roll1, roll2)], for a total of [roll[i]].</font>";
						else
						{
							if (attacker.class == "Assassin")
							{
								src.turf.contents << "<font color=#800000>\The [src.sides[i]] rolls double [roll1]'s, scoring a critical hit for [roll1 * 4] plus [CalcAdds(src.sides[i], src.sides[3 - i], roll1, roll2)], totalling at [roll[i] + roll1 * 2].</font>";
								roll[i] = roll[i] + roll1 + roll2;
							}
							else
								src.turf.contents << "<font color=#F00000>\The [src.sides[i]] rolls double [roll1]'s, plus [CalcAdds(src.sides[i], src.sides[3 - i], roll1, roll2)], for a total of [roll[i]].</font>";
						}
					}
					else
						src.turf.contents << "<font color=#F00000>\The [src.sides[i]] rolls a [roll1], a [roll2], and a [roll3], plus [CalcAdds(src.sides[i], src.sides[3 - i], roll1, roll2)], for a total of [roll[i]].</font>";
				}
				else
				{
					roll1 = roll(1, 6);
					if (attacker.type == /mob/monster/rare/chimera && attacker.curlife > attacker.life / 2)
						roll2 = roll(1, 6);
					else
						roll2 = 0;

					if (attacker.lucky)
					{
						attacker.lucky--;
						roll1 = 6;
					}

					roll[i] = roll1 + roll2 + CalcAdds(src.sides[i], src.sides[3 - i], roll1, 0);
					if (roll2 == 0)
						src.turf.contents << "<font color=#F00000>\The [src.sides[i]] rolls a [roll1], plus [CalcAdds(src.sides[i], src.sides[3 - i], roll1, 0)], for a total of [roll[i]].</font>";
					else
						src.turf.contents << "<font color=#F00000>\The [src.sides[i]] rolls a [roll1] and a [roll2], plus [CalcAdds(src.sides[i], src.sides[3 - i], roll1, roll2)], for a total of [roll[i]].</font>";
				}
			}

			var/i;

			if (roll[1] > roll[2])
				i = 2;
			else if (roll[2] > roll[1])
				i = 1;

			if (i == null)
			{
				src.turf.contents << "<font color=#a00060>Wearily the two combatants fight to a draw.</font>";
				return;
			}

			var/mob/winner = src.sides[3 - i];
			var/mob/loser = src.sides[i];
			var/diff = roll[3 - i] - roll[i] - 1;
			var/hits = 1;

			if (winner.weapon && winner.weapon.type == /obj/item/legendary/dragonslayer && loser.type == /mob/monster/legendary/dragon)
				hits *= 2;

			if (!winner.weapon || !(winner.weapon.type == /obj/item/legendary/doom_axe))
				hits -= (loser.defend + loser.def_adds);

			winner.def_adds = 0;
			loser.def_adds = 0;

			if ((loser.armor && rand(1,100) > loser.armor.durability && loser.class != "Blacksmith" && loser.armor.broken != 1) || (loser.armor && loser.armor.broken != 1 && winner.type == /mob/monster/legendary/rot_fiend && loser.armor.durability != 100))
			{
				if (winner.type == /mob/monster/legendary/rot_fiend)
					loser << "<font color=#00A000>Your armor corrodes under the rot fiend's withering touch!</font>";

				loser << "<font color=#A0A0A0>Your armor is broken!</font>";
				loser.armor.TakeAdds();
				loser.score -= loser.armor.worth;
				loser.armor.defend_adds = 0;
				loser.armor.new_defense = loser.nat_defense;
				loser.armor.worth = 0;
				loser.armor.broken = 1;
				loser.armor.icon_state = "broken " + loser.armor.icon_state;
				loser.armor.name = "broken " + loser.armor.name;
				loser.armor.desc = "A broken and useless piece of equipment.";
			}

			while (diff > 1)
			{
				if (winner.class != "Sprite")
					diff -= 2;
				else
				{
					if (diff < 8)
						break;
					else
						diff -= 8;
				}

				var/hitlist[] = list();
				var/hit = 0;

				if (rand(1,5) - loser.companions.len <= 1)
				{
					for (var/mob/companion/C in loser.companions)
					{
						if (C && C.rank == 1) hitlist.Add(C);
					}

					for (var/k=1, k<=hitlist.len, k++)
					{
						if (rand(1, hitlist.len + 1 - k) == 1)
						{
							var/msglist = src.turf.contents;
							hit = 1;
							var/mob/companion/C = hitlist[k];
							if (rand(1, 100) > C.resist)
							{
								if (loser.class == "Surgeon" && rand(1,3) <= 2)
								{
									src.turf.contents << "<font color=#A0A0A0>\The [hitlist[k]] is hit, but survives thanks to [loser]'s medical skill!</font>";
								}
								else
								{
									var/save = 0;
									for (var/mob/companion/D in loser.companions)
									{
										if (D.type == /mob/companion/rare/surgeon && rand(1, 3) <= 2 && C != D)
										{
											src.turf.contents << "<font color=#A0A0A0>\The [hitlist[k]] is hit, but survives thanks to the attention of [loser]'s surgeon!</font>";
											save = 1;
										}
									}

									if (save == 0)
									{
										msglist << "<font color=#A0A000>\The [hitlist[k]] is killed!</font>";
										loser.companions.Remove(hitlist[k]);
										var/mob/t = hitlist[k];
										hitlist.Remove(t);
										del(t);
									}
								}
							}
							else
							{
								if (istype(hitlist[k], /mob/companion/rare/sprite))
									src.turf.contents << "<font color=#C0C0C0>\The [hitlist[k]] dodges out of the way and diverts [winner]'s blow!</font>";
								else
									src.turf.contents << "<font color=#A0A0A0>\The [hitlist[k]] is hit, but ignores the damage and continues fighting!</font>";
							}
						}
					}
				}

				if (hit == 0)
					hits++;
			}

			hits = max(0, hits);

			var/j;

			for (j=1, j<=hits, j++)
			{
				if (winner.accuracy)
				{
					winner.accuracy--;
					break;
				}

				if (rand(1,100) > min(96, loser.block))
				{
					break;
				}
			}

			if (hits <= 0)
			{
				src.turf.contents << "\The [loser] [loser.defense] [winner]'s blow!";
			}
			else if (j > hits)
			{
				if ((loser.shield && rand(1,100) > loser.shield.durability && loser.class != "Blacksmith" && loser.shield.broken != 1) || (loser.armor && loser.armor.broken != 1 && winner.type == /mob/monster/legendary/rot_fiend && loser.shield.durability != 100))
				{
					if (winner.type == /mob/monster/legendary/rot_fiend)
						loser << "<font color=#00A000>Your shield corrodes under the rot fiend's withering touch!</font>";

					loser << "<font color=#A0A0A0>Your shield is broken!</font>";
					loser.shield.TakeAdds();
					loser.score -= loser.shield.worth;
					loser.shield.block_adds = 0;
					loser.shield.worth = 0;
					loser.shield.new_block = loser.nat_blocks;
					loser.shield.broken = 1;
					loser.shield.icon_state = "broken " + loser.shield.icon_state;
					loser.shield.name = "broken " + loser.shield.name;
					loser.shield.desc = "A broken and useless piece of equipment.";
				}

				hits = 0;
				src.turf.contents << "<font color=#A0A0A0>\The [loser] [loser.blocks] [winner]'s blow!</font>";
			}
			else if (hits > 0)
			{
				src.turf.contents << "<font color=#A00060>\The [winner] wounds [loser] for [hits] damage!</font>";
				if (winner.weapon && winner.weapon.poison)
				{
					winner.weapon.poison--;
					if (loser.class == "Surgeon")
					{
						src.turf.contents << "<font color=#A0A000>\The [loser] shudders from poison, but manages to treat it quickly with a handy antitoxin.</font>";
					}
					else if (loser.undead != 1)
					{
						hits++;
						src.turf.contents << "<font color=#00A000>\The [loser] shudders and takes 1 additional damage as deadly venom flows through \his veins!</font>";
					}
				}
			}

			loser.curlife -= hits;

			if (loser.curlife < 1)
			{
				src.turf.contents << "<font color=#580000>\The [loser] is slain!</font>";
				loser.Die();

				src.turf.combat = null;
				src.turf.RevealAll();
				winner.combat = null;
				winner.opponent = null;
				del(src);
			}
		}
	}
}