/mob
{
	companion
	{
		var
		{
			rank = 0;

			resist = 0;

			served[] = list();

			mob/player/leader;
		}

		verb
		{
			greet()
			{
				set src in usr.loc;

				src.Greeting();
			}

			dismiss()
			{
				set src in usr;

				src.Dismissal();
			}

			rank()
			{
				set src in usr;

				src.Rankage();
			}

			special()
			{
				set src in usr;

				src.Special();
			}
		}

		proc
		{
			Greeting()
			{
				if (!(src in usr.loc.contents))
					return;

				if (usr.class == "Ninja")
				{
					usr << "The Ninja need no companions!";
					return;
				}

				if (usr.class == "Zombie")
				{
					usr << "\The [src] screams in terror at you!";
					return;
				}

				if (usr.companions.len >= usr.charisma)
				{
					usr << "You've already got as many companions as you can have!";
					return;
				}

				src.loc.contents - usr << "[usr] calls out to [src], who gladly joins their party.";
				usr << "You greet [src], who gladly joins you.";

				src.loc = usr;
				usr.companions.Add(src);
				usr.loc:RevealAll();
				src.leader = usr;
			}

			Dismissal()
			{
				src.loc.contents - usr << "\A [src.name] dejectedly leaves [usr]'s party as \he dismisses them.";
				usr << "[src] goes off \his own way.";
				src.loc = usr.loc;
				usr.companions.Remove(src);

				usr.loc:RevealAll();
				src.leader = null;
			}

			Rankage()
			{
				if (src.rank == 0)
				{
					usr << "Set [src] to fighting ranks. \He will now assist you in combat.";
					src.rank = 1;
					src.suffix = "(fighting)";
				}
				else
				{
					usr << "Set [src] to passive ranks. \He will now sit out of combat.";
					src.rank = 0;
					src.suffix = "";
				}
			}

			Special()
			{
				usr << "Unfortunately, [src] has no special skills to use.";
			}
		}

		common
		{
			soldier
			{
				attack = 1;
				rank = 1;
				suffix = "(fighting)";

				icon = 'soldier.dmi';

				desc = "A hardened warrior, the Soldier will help his party leader in combat.";
			}

			squire
			{
				attack = 1;
				rank = 1;
				suffix = "(fighting)";

				icon = 'squire.dmi';

				desc = "A spry young lad, the Squire will gladly defend his master.";
			}

			swashbuckler
			{
				attack = 1;
				rank = 1;
				suffix = "(fighting)";

				icon = 'swashbuckler.dmi';

				desc = "An expert swordsman, the Swashbuckler will defend his leader well.";
			}

			thug
			{
				attack = 1;
				rank = 1;
				suffix = "(fighting)";

				icon = 'thug.dmi';

				desc = "A big ugly brute, the Thug will lend you his muscle in combat.";
			}

			mercenary
			{
				attack = 1;
				rank = 1;
				suffix = "(fighting)";
				resist = 50;

				icon = 'mercenary.dmi';

				desc = "A seasned veteran and expert warrior, the Mercenary will help you... for a price.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Ninja")
					{
						usr << "The Ninja need no companions!";
						return;
					}

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}

					var/inventory[] = list();
					inventory.Add(usr.contents);
					inventory.Remove(usr.companions);
					inventory.Add("Cancel");

					for (var/obj/item/I in inventory)
					{
						if (I.type == /obj/item/treasure_hoard)
							inventory.Remove(I);
					}

					if (inventory.len == 1)
					{
						usr << "\The [src] tells you, \"You don't have anything to pay me with!\"";
						return;
					}

					var/choice = input("\"Sure, I'll work for you... but for payment I'll need something worth at least 5 points, paid upfront.\"", "Mercenary Hiring") in inventory;

					if (choice == "Cancel")
						return
					else
					{
						if (!isobj(choice))
							return;

						var/obj/item/item = choice;
						if (item.worth < 5)
						{
							usr << "\The [src] sneers. \"Whaddya tryin' to pull? That ain't worth nothin'.\"";
							return;
						}
						else
						{
							usr.score -= item.worth;
							del(item);
						}
					}

					src.loc.contents - usr << "[usr] pays \a [choice] to [src] in exchange for \his services.";
					usr << "You pay [src] \the [choice], and he joins your party.";

					src.loc = usr;
					usr.companions.Add(src);
					usr.loc:RevealAll();
					src.leader = usr;
				}
			}

			healer
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'chemist.dmi';

				desc = "A skilled medic, the Healer will restore your life if you pay him.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}
					else if (usr.curlife >= usr.life)
					{
						usr << "\The [src] tells you, \"You don't look like you need my help.\"";
						return
					}

					var/inventory[] = list();
					inventory.Add(usr.contents);
					inventory.Remove(usr.companions);
					inventory.Add("Cancel");

					for (var/obj/item/I in inventory)
					{
						if (I.type == /obj/item/treasure_hoard)
							inventory.Remove(I);
					}

					if (inventory.len == 1)
					{
						usr << "\The [src] tells you, \"You don't have anything to pay me with!\"";
						return;
					}

					var/choice = input("\"Hmm, that is a nasty wound... I think I can fix it up, but I'll need a little something in exchange\"", "Healer's Fee") in inventory;

					if (choice == "Cancel")
						return
					else
					{
						if (!isobj(choice))
							return;

						var/obj/item/item = choice;
						if (item.worth < 10)
						{
							usr << "\The [src] scoffs. \"Certainly my services are worth more than that!\"";
							return;
						}
						else
						{
							usr.curlife = min(usr.curlife + 2, usr.life);
							usr.score -= item.worth;

							while (item.worth >= 20)
							{
								item.worth -= 10;
								usr.curlife = min(usr.curlife + 1, usr.life);
							}

							del(item);
						}
					}

					src.loc.contents - usr << "[usr] pays \a [choice] to [src] in exchange for \his medical attention.";
					usr << "You pay [src] \the [choice], and he carefully applies a bitter-smelling salve to your wounds. Almost instantly you feel better.";
				}
			}
		}

		unusual
		{
			alchemist
			{
				attack = 1;
				rank = 0;
				suffix = "";

				icon = 'chemist.dmi';

				desc = "A busy chemist has set up his laboratory here.";

				var/obj/item/sale;

				New()
				{
					var/t;
					switch (rand(1, 8))
					{
						if (1) t = /obj/item/unusual/strength_potion;

						if (2) t = /obj/item/unusual/defense_potion;
//						if (3) t = /obj/item/rare/speed_potion;
						if (4) t = /obj/item/rare/acid_vial;
						else t = /obj/item/unusual/healing_potion;
					}

					src.sale = new t(src);
				}

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}

					var/inventory[] = list();
					inventory.Add(usr.contents);
					inventory.Remove(usr.companions);
					inventory.Add("Cancel");

					for (var/obj/item/I in inventory)
					{
						if (I.type == /obj/item/treasure_hoard)
							inventory.Remove(I);
					}

					if (inventory.len == 1)
					{
						usr << "\The [src] says to you, \"I'm not running a charity outfit here--bring cash or I won't give you anything.\"";
						return;
					}

					var/choice = input("\The [src] says to you, \"Have I got a deal for you! I just brewed up this here [src.sale.name], and I'll sell it to you for the low price of [round(src.sale.worth / 2)]! How about it?\"", "Buying Potions") in inventory;

					if (choice == "Cancel")
						return;
					else
					{
						if (!isobj(choice))
							return;

						var/obj/item/item = choice;
						if (item.worth < round(src.sale.worth / 2))
						{
							usr << "\The [src] rolls \his eyes. \"I thought we had agreed on a price already!\"";
							return;
						}
						else
						{
							usr.score -= item.worth;
							del(item);
							src.sale.loc = usr;
							if (usr.class == "Merchant") src.sale.worth = round(src.sale.worth * 1.20, 1);
							usr.score += src.sale.worth;
						}
					}

					src.loc.contents - usr << "[usr] hands \a [choice] to [src], who produces a [src.sale.name].";
					usr << "You give [choice] to [src], and he hands you a fresh [src.sale.name].";
					src.loc.contents << "\The [src] says, \"Well, that's the last of my stock. Off to find s'more supplies...\"";

					del(src);
				}
			}

			blacksmith
			{
				attack = 1;
				rank = 0;
				suffix = "";

				icon = 'blacksmith.dmi';

				desc = "A soot-covered blacksmith is working hard at his forge here.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}

					var/inventory[] = list();
					inventory.Add(usr.contents);
					inventory.Remove(usr.companions);
					inventory.Add("Cancel");

					if (inventory.len == 1)
					{
						usr << "\The [src] says to you, \"I'd love to lend you a hand, but you don't have any items needing mending.";
						return;
					}

					var/choice = input("\"What, you're searching for the Legendary Treasure Hoard? Hah! Looks like you'll need all the help you can get... tell you what, I'll repair your broken equipment for you. No charge--just doing what I do best.\"", "Equipment Repair") in inventory;
					var/obj/item/old = choice;

					if (choice == "Cancel")
						return;
					else
					{
						if (!isobj(choice))
							return;

						var/obj/item/item = choice;
						if (item.broken == 0)
						{
							usr << "\The [src] rolls \his eyes. \"That doesn't need any fixing!\"";
							return;
						}
						else
						{
							var/t = item.type;
							var/obj/item/tt = new t(usr);
							spawn(1) del(item);
							usr.score += tt.worth;
						}
					}

					src.loc.contents - usr << "[usr] hands \a [old] to [src], who happily goes to work repairing it.";
					usr << "You give [old] to [src], and he quickly mends it for you. \"Good as new,\" he says with a wink.";
				}
			}

			crusader
			{
				attack = 1;
				rank = 1;
				suffix = "(fighting)";

				icon = 'crusader.dmi';

				desc = "A fanatic warrior, the Crusader will assist you in your quest.";
			}

			dwarf
			{
				attack = 1;
				rank = 1;
				resist = 30;
				suffix = "(fighting)";

				icon = 'dwarf.dmi';

				desc = "A short, hardy warrior, the Dwarf will assist you in combat and has a chance of taking a blow without dying.";
			}

			barbarian
			{
				attack = 1;
				rank = 1;
				resist = 10;
				suffix = "(fighting)";

				icon = 'barbarian.dmi';

				desc = "A fierce, savage warrior, the Barbarian will lend you his strength in combat.";
			}

			priest
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'priest.dmi';

				desc = "This holy father of the church will give you a point of life once per game.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.undead)
					{
						usr << "\The [src] gapes in horror at the sight of you. Raising \his hands to the heavens, he shouts out, \"O holy father! Give me the power to smite this abomination!\" Suddenly you find yourself obliterated by a bolt of holy energy.";
						usr.Die();
						return;
					}
					else if (usr.curlife >= usr.life)
					{
						usr << "\The [src] tells you, \"You don't seem to require any assistance, my son.\"";
						return;
					}
					else if (usr in src.served)
					{
						usr << "\The [src] tells you, \"You have already been blessed as best I can. The rest is up to you.\"";
						return;
					}

					src.loc.contents - usr << "[usr] kneels before [src] and is blessed by \him.";
					usr << "You kneel before [src], who lightly sprinkles your forehead with holy water and chants a small prayer. Almost instantly you feel better.";
					src.served.Add(usr);

					usr.curlife = min(usr.curlife + round(usr.life / 2), usr.life);
				}
			}
		}

		rare
		{
			thief
			{
				attack = 1;
				rank = 0;
				suffix = "";

				icon = 'thief.dmi';

				desc = "A sly burglar, the Thief can steal treasure even while it's being guarded by monsters.";
			}

			surgeon
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'doctor.dmi';

				desc = "The Surgeon is a skilled physician who can help keep your other companions from dying in battle.";
			}

			sprite
			{
				attack = 0;
				rank = 1;
				resist = 90;
				suffix = "(fighting)";

				icon = 'sprite.dmi';

				desc = "This nimble Sprite will help you in combat--although he can't do much damage, he can distract enemies and divert their blows.";
			}

			knight
			{
				attack = 1;
				rank = 1;
				suffix = "(fighting)";

				var/greeted = 0;

				icon = 'knight.dmi';

				desc = "A noble warrior, the knight and his trusty squire will greatly assist you in combat.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Ninja")
					{
						usr << "The Ninja need no companions!";
						return;
					}

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}

					src.loc = usr;
					usr.companions.Add(src);
					if (src.greeted == 0)
					{
						src.loc.contents - usr << "[usr] calls out to [src], who gladly joins their party along with \his squire.";
						usr << "You greet [src], who gladly joins you with his squire.";
						usr.companions.Add(new/mob/companion/common/squire(usr));
						src.greeted = 1;
					}
					else
					{
						src.loc.contents - usr << "[usr] calls out to [src], who gladly joins their party.";
						usr << "You greet [src], who gladly joins you.";
					}
					usr.loc:RevealAll();
					src.leader = usr;
				}
			}

			seer
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'seer.dmi';

				desc = "A mysterious prophet with strange powers, the Seer can sense life forms in the surrounding rooms.";

				Special()
				{
					var/bodycount;
					var/dirname;
					var/found = 0;
					for (var/dir in dirlist)
					{
						var/turf/check = get_step(usr.loc, dir);
						bodycount = 0;

						if (!check) continue;

						for (var/atom/A in check.contents)
						{
							if (ismob(A) && A:undead == 0)
								bodycount++;
						}

						if (bodycount > 0)
						{
							found = 1;

							switch(dir)
							{
								if (1) dirname = "north";
								if (2) dirname = "south";
								if (4) dirname = "east";
								if (8) dirname = "west";
							}

							usr << "Your [src.name] tells you, \"I sense [bodycount] life form\s to the [dirname]\".";
						}
					}

					if (found == 0)
						usr << "Your [src.name] tells you, \"I cannot detect any life force from the surrounding rooms.\"";
				}
			}

			merchant
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'merchant.dmi';

				desc = "A wealthy-looking merchant is here, eagerly fingering his purse.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}

					var/inventory[] = list();
					inventory.Add(usr.contents);
					inventory.Remove(usr.companions);
					for (var/obj/item/I in inventory)
					{
						if (I.type == /obj/item/treasure_hoard)
							inventory.Remove(I);
					}
					inventory.Add("Cancel");

					if (inventory.len == 1)
					{
						usr << "\The [src] says to you, \"I'd be happy to do business with you, but it doesn't look like you have anything to sell\"";
						return;
					}

					var/choice = input("\"Ah, my friend, I have been combing these dungeons for exotic treasures for too long. You look like you've been quite successful--perhaps you'd sell some of your equipment? I pay in cash.\"", "Merchant Trade") in inventory;

					if (choice == "Cancel")
						return;
					else
					{
						if (!isobj(choice))
							return;

						var/obj/item/item = choice;
						if (item.worth < 5)
						{
							usr << "\The [src] rolls \his eyes. \"You insult me with such an offer! I want none of your trash!\"";
							return;
						}
						else if (istype(item, /obj/item/common))
						{
							usr << "\The [src] gives you an odd look. \"You want me to buy common coins from you?\"";
							return;
						}
						else
						{
							var/total = item.worth;
							usr.score -= total;
							var/obj/item/tt;

							while (total > 75)
							{
								total -= 36;
								tt = new /obj/item/common/gold_coins(usr);
								if (usr.class == "Merchant") tt.worth = round(tt.worth * 1.20, 1);

								usr.score += tt.worth;
							}

							while (total > 15)
							{
								total -= 12;
								tt = new /obj/item/common/silver_coins(usr);
								if (usr.class == "Merchant") tt.worth = round(tt.worth * 1.20, 1);

								usr.score += tt.worth;
							}

							while (total > 0)
							{
								total -= 4;
								tt = new /obj/item/common/copper_coins(usr);
								if (usr.class == "Merchant") tt.worth = round(tt.worth * 1.20, 1);

								usr.score += tt.worth;
							}

							del(item);
						}
					}

					src.loc.contents - usr << "[usr] sells \a [choice] to [src], who gladly hands him a sack of money.";
					usr << "You give [choice] to [src], and he promptly counts out its value in coinage. \"Ah, yes, very good! A pleasure doing business with you!\" he says.";
				}
			}

			scout
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'scout.dmi';

				desc = "The Scout isn't much use in a fight, but he can peek into the contents of adjacent rooms for you once per turn.";

				var/survey_turn;

				Special()
				{
					if (src.survey_turn >= turn)
					{
						usr << "You've already had [src] this turn!";
						return;
					}

					dir = input("Survey in which direction?", "Survey") in list("north", "east", "south", "west")

					var/check;
					switch (dir)
					{
						if ("north") check = 1;
						if ("south") check = 2;
						if ("east") check = 4;
						if ("west") check = 8;
					}

					if (!check) return;

					var/turf/T = get_step(usr.loc, check);

					if (T && T.Enter(usr))
					{
						usr << "The scout looks [dir]ward...";
						T.Reveal(usr);
						src.survey_turn = turn;
					}
					else
						usr << "Scouts may have eagle eyes, but they don't have x-ray vision--try having him look into an open room instead.";
				}
			}

			bounty_hunter
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'bounty.dmi';

				desc = "A soldier of fortune with connections, the Bounty Hunter will gladly get a bounty posted on a player of your choice if you pay him properly.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}

					var/inventory[] = list();
					inventory.Add(usr.contents);
					inventory.Remove(usr.companions);
					inventory.Add("Cancel");

					for (var/obj/item/I in inventory)
					{
						if (I.type == /obj/item/treasure_hoard)
							inventory.Remove(I);
					}

					if (inventory.len == 1)
					{
						usr << "\The [src] tells you, \"You don't have anything to pay me with!\"";
						return;
					}

					var/choice = input("\"Sure I could declare a bounty for you, but it'll cost you... 50 points.\"", "Declaring Bounty") in inventory;

					if (choice == "Cancel")
						return
					else
					{
						if (!isobj(choice))
							return;

						var/obj/item/item = choice;
						if (item.worth < 50)
						{
							usr << "\The [src] shrugs. \"Look, I can't arrange anything for you for that little.\"";
							return;
						}
						else
						{
							var/targets[] = list();
							targets.Add(players);
							targets.Remove(usr);

							if (targets.len == 0)
							{
								usr << "\The [src] tells you, \"Sorry, but there's no one else in these parts to post a bounty on.\"";
								return;
							}

							var/mob/target = input("\"So who's the target?\"", "Declaring Bounty") in targets;

							target.bounty = 250;
							spawn(1) players << "<B>A bounty has been declared on the head of [target]! Anyone who manages to kill \him will get an extra 250 bonus points!";

							usr.score -= item.worth;
							del(item);
						}
					}

					src.loc.contents - usr << "[usr] pays \a [choice] to [src], who strides off hurriedly.";
					usr << "You pay [src] \the [choice], who quickly goes off to post your bounty.";

					spawn(2) del(src);
				}
			}

			scholar
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'scholar.dmi';

				desc = "A learned scholar looks about eagerly, fingering a valuable relic.";

				var/obj/item/sale;

				New()
				{
					var/t;
					switch (rand(1, 8))
					{
						if (1) t = /obj/item/rare/attack_amulet;
						if (2) t = /obj/item/rare/amulet_of_protection;
						if (3) t = /obj/item/rare/ring_of_invisibility;
						if (4,7) t = /obj/item/rare/ring_of_warning;
						if (5) t = /obj/item/rare/ring_of_vampirism;
						if (6) t = /obj/item/rare/arcane_robes;
						if (8) t= /obj/item/rare/pegasus_wings;
					}

					src.sale = new t(src);
				}

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}

					var/inventory[] = list();
					inventory.Add(usr.contents);
					inventory.Remove(usr.companions);
					inventory.Add("Cancel");

					for (var/obj/item/I in inventory)
					{
						if (I.type == /obj/item/treasure_hoard)
							inventory.Remove(I);
					}

					if (inventory.len == 1)
					{
						usr << "\The [src] looks at you up and down, then says, \"I trade in relics--if you had something worthwhile to exchange, I'd be happy to trade an item or two of my own, but you seem to lack anything of interest.\"";
						return;
					}

					var/choice = input("\The [src] says to you, \"Ah, salutations! I was just wandering through this labyrinth, collecting relics to study, but my searches go poorly. You look like you might have something of value to me on you--perhaps you'd be willing to trade something worth [src.sale.worth] for this [src.sale]?\"", "Relic Swapping") in inventory;

					if (choice == "Cancel")
						return;
					else
					{
						if (!isobj(choice))
							return;

						var/obj/item/item = choice;
						if (item.worth < round(src.sale.worth))
						{
							usr << "\The [src] studies [item] carefully and shrugs. \"Sorry, but I don't think this will do at all.\"";
							return;
						}
						else
						{
							usr.score -= item.worth;
							del(item);
							src.sale.loc = usr;
							if (usr.class == "Merchant") src.sale.worth = round(src.sale.worth * 1.20, 1);
							usr.score += src.sale.worth;
						}
					}

					src.loc.contents - usr << "[usr] hands \a [choice] to [src], who produces a [src.sale.name].";
					usr << "You give [choice] to [src], and he hands you a mysterious [src.sale.name].";
					src.loc.contents << "\The [src] says, \"Perfect! Just what I needed! Now, let's see...\" He wanders off, lost in thought.";

					del(src);
				}
			}

			wizard
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'wizard.dmi';

				desc = "This ancient sorceror looks about him with the wisdom of ages.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Zombie")
					{
						usr << "\The [src] screams in terror at you!";
						return;
					}
					else if (usr.lore > 6)
					{
						usr << "\The [src] tells you, \"Your skill in lore is great. There is nothing I can teach you.\"";
						return;
					}
					else if (usr in src.served)
					{
						usr << "\The [src] tells you, \"I have already given you my arcane knowledge. There is nothing more I can teach you.\"";
						return;
					}

					src.loc.contents - usr << "\The [src] gives [usr] a lesson in arcane lore.";
					usr << "You sit with [src] a while, and \he tells you much mystical lore.";

					src.served.Add(usr);

					usr.lore++;
				}
			}
		}

		legendary
		{
			devil
			{
				attack = 2;
				rank = 1;
				resist = 100;
				suffix = "(fighting)";

				icon = 'devil.dmi';

				desc = "The devil's skin gleans evilly in the flickering light, and he flashes you a toothy grin. He seems willing to bargain.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Ninja")
					{
						usr << "The Ninja need no companions!";
						return;
					}

					if (usr.class == "Zombie" || usr.class == "Ghost")
					{
						usr << "\The [src] scoffs at you. \"I don't believe you can offer me what it is I want in exchange for my services.\"";
						return;
					}

					if (usr.class == "Crusader" || usr.class == "Knight")
					{
						usr << "\The [src] grins at you. \"Foolish mortal--you know not the powers you are dealing with!";
						return;
					}

					if (usr.class == "Priest")
					{
						usr.loc.contents << "[usr] screams at [src], \"I command thee--begone, foul creature! Take leave of this plane and return to the nether regions from whence you were spawned!\"<BR>With a shriek of terror, [src] vanishes in a swirl of foul-smelling smoke, leaving only charred hoofprints in the ground.";
						del (src);
						return;
					}

					for (var/mob/companion/C in usr.companions)
					{
						if (C.type == /mob/companion/legendary/devil)
						{
							usr << "\The [src] says to you, \"I believe you're already... spoken for.\" and turns away.";
						}
					}

					if (alert(usr, "\"Hrrm,\" the devil begins. \"I don't offer my services to any asker, but I can tell that you, surely, are a hero of high stature. You have something... something that I want. Let's make a bargain, shall we? A little bit of your life force... just a fraction, really... and my powers will be at your command.", "The Devil's Pitch", "Yes", "No") == "No")
					{
						usr.loc.contents - usr << "\The [src] scoffs at [usr]. \"Pathetic mortal.\"";
						usr << "\The [src] scoffs at you. \"Pathetic mortal.\"";
						return;
					}
					else
					{
						src.loc.contents - usr << "\The [src] hands [usr] an iron pen, and [usr] eagerly signs a small black book in exchange for [src]'s service.";
						usr << "You eagerly prick your finger and proceed to sign your name in blood on a small book [src] produces, and with a grin \he joins your party.";
						usr.curlife = round(usr.curlife / 2, 1);
						usr << "\"Oh, and by the way,\" the devil whispers to you, \"I'll be needing your immortal soul. But I imagine you had already gathered that.\"";
					}

					src.loc = usr;
					usr.companions.Add(src);
					usr.loc:RevealAll();
					src.leader = usr;
				}

				Dismissal()
				{
					usr << "\The [src] snickers. \"Pitiable fool,\" he says, with an air that clearly states he has no intention of leaving.";
				}
			}

			wisp
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'wisp.dmi';

				desc = "A mysterious twinkling light dances about the room, blinking in and out of existence from time to time.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (alert("\"Hmm. You mortal beings always seem to be off moving to and fro on your legs for some reason or another. Such silly movement on so backwards a means for so pointless a purpose you always have. Scurry about no longer, mortal! I will clear a path for you to wherever you wish to go.\"", "Wisp", "OK", "No thanks") == "No thanks")
					{
						usr << "\"Poor fool,\" the wisp says before returning to its contemplations.";
						return;
					}

					var/x = 0;
					var/y = 0;
					var/z = 0;

					while (x < 1 || x > world.maxx) x = input("X coordinate?", "Teleport") as num;
					while (y < 1 || y > world.maxy) y = input("Y coordinate?", "Teleport") as num;
					while (z < 1 || z > world.maxz) z = input("Dungeon level?", "Teleport") as num;

					if (x == 7 && y == 8 && z == 3)
					{
						usr << "The wisp says, \"Interesting... some force seeks to shield this room from me. I must contemplate on the meaning of this.\"";
						return;
					}

					usr << "The wisp says, \"As you will.\"";
					usr.loc.contents - usr << "Twinkling lights dance around [usr] as \he phases out of existence.";
					usr << "A tingling sensation comes over you as you fade out of existence, only to rematerialize elsewhere.";

					var/turf/oldloc = usr.loc;

					usr.loc = locate(x, y, z);
					usr.loc:RevealAll();
					oldloc.RevealAll();
				}
			}

			ghost
			{
				attack = 0;
				rank = 0;
				suffix = "";

				icon = 'ghost.dmi';

				desc = "This haunting apparition looks about with an eye for mischief.";

				Greeting()
				{
					if (!(src in usr.loc.contents))
						return;

					if (usr.class == "Priest")
					{
						usr.loc.contents << "[usr] raises his cross at [src]. \"O holy father!Take this haunting sight from before my eyes!\" \The [src] is suddenly whisked away into nothingness by a blinding flash of light.";
						del (src);
						return;
					}
					else if (usr.class == "Crusader")
					{
						usr.loc.contents << "[usr] charges at [src], startling it and causing it to float off.";
						del (src);
						return;
					}

					var/targets[] = list();
					targets.Add(players);
					targets.Remove(usr);

					if (targets.len == 0)
					{
						usr << "\The [src] suddenly gets a malevolent look in its eye. With unearthly howls and nightmarish shrieks, it chases after your party!";

						for (var/mob/companion/C in usr.companions)
						{
							if (!(istype(C, /mob/companion/legendary)) && rand(1,5) >= 3)
							{
								usr << "Your [C.name] runs away in terror!";
								usr.companions.Remove(C);
								del(C);
							}
						}
						usr << "Having had its fun, [src] departs.";
						del (src);
						return;
					}

					var/mob/target = input("\The [src] looks at you incredulously. \"A living person? Down here? Oh, but it's been so long since I've had a chance to have a nice proper haunt! Maybe you could point me to someone I could go and have a little scare at, just for fun?\"", "Lonely Ghost") in targets;

					src.loc.contents - usr << "\The [src] suddenly turns bright and floats off happily.";
					usr << "\The [src] is overcome with joy as it floats off. \"Finally, someone to haunt! OooooOOOOOOooooooo!\"";

					target.loc << "A ghost suddenly pops into the room!";
					target << "With unearthly howls and shrieks, [src] chases after your party!";

					for (var/mob/companion/C in target.companions)
					{
						if (!(istype(C, /mob/companion/legendary)) && rand(1,2) == 1)
						{
							target.loc << "\The [C] runs away in terror!";
							target.companions.Remove(C);
							del(C);
						}
					}
					target << "Having had its fun, [src] departs.";

					del (src);
				}
			}

			hero
			{
				attack = 2;
				rank = 1;
				suffix = "(fighting)";
				resist = 50;

				icon = 'hero.dmi';

				desc = "A legendary champion, the Hero is a valiant warrior who will help you greatly in combat..";
			}
		}
	}
}