/var
{
	scores[] = list();
	ended = 0;
}

/score
{
	var
	{
		owner;
		total;
	}
}

proc/DoEndGame()
{
	players << "<B>The Legendary Treasure Hoard has been reclaimed by [usr], and the game is over after [turn] turns!</B>";

	var/score/S = new();
	S.owner = usr.name;
	S.total = usr.score;
	scores.Add(S);

	for (var/mob/player/P in world)
	{
		if (P == usr) continue;

		if (P.type != /mob/player)
		{
			P.score -= (turn - P.pturn) * 2;
			P.score = max(P.score, 0);

			S = new();
			S.owner = P.name;
			S.total = P.score;
			scores.Add(S);
		}
	}

	ended = 1;

	for (var/mob/player/P in players)
	{
		ShowScores(P);
	}

	world << "A new game will begin in 30 seconds...";

	spawn(300) world.Reboot();
}

proc/ShowScores(mob/player/P)
{
	P << "<B>Best scores this game:</B>";

	var/unordered[] = list();
	unordered.Add(scores);
	var/ordered[] = list();

	var/highest = 0;

	while (ordered.len < scores.len)
	{
		highest = 0;
		for (var/score/S in unordered)
		{
			if (S.total >= highest)
			{
				highest = S.total;
			}
		}

		for (var/score/S in unordered)
		{
			if (S.total == highest)
			{
				unordered.Remove(S);
				ordered.Add(S);
				break;
			}
		}
	}

	for (var/score/S in ordered)
		P << "[S.total] points by [S.owner]";
}