/*
ITEM IDEAS

Unusual- Whip (+1 attack, hard to break)
Unusual- Spear (+1 attack)
Rare- Magic Knife (+1 attack, unbreakable)
Legendary- Magic Bow (+4 to attack, reload, unbreakable)
*/

/var
{
	potionlist[] = list();
}

/proc
{
	InitPotionList()
	{
		potionlist.Cut();
		potionlist["Water"] = /obj/item/unusual/water;
		potionlist["Acid"] = /obj/item/rare/acid_vial;
		potionlist["Poison"] = /obj/item/rare/poison_vial;
		potionlist["Healing Potion"] = /obj/item/unusual/healing_potion;
		potionlist["Potion of Strength"] = /obj/item/unusual/strength_potion;
		potionlist["Potion of Protection"] = /obj/item/unusual/defense_potion;
		potionlist["Potion of Ethereality"] = /obj/item/rare/ghost_potion;
		potionlist["Potion of Enlightenment"] = /obj/item/rare/wisdom_potion;
		potionlist["Potion of Far-Seeing"] = /obj/item/rare/farsight_potion;
		potionlist["Potion of Accuracy"] = /obj/item/rare/accuracy_potion;
	}
}

/obj
{
	item
	{
		layer = AREA_LAYER;

		var
		{
			worth;
			equipped;
			attack_adds = 0;
			lore_adds = 0;
			charisma_adds = 0;
			defend_adds = 0;
			new_defense = "";

			broken = 0;

			poison = 0;

			constant_use = 0;

			loaded = 1;

			block_adds = 0;
			new_block = "";

			durability = 100;

			item_type = "";
		}

		common
		{
			copper_coins
			{
				name = "pile of copper coins";
				worth = 5;
				icon = 'valuable.dmi';
				icon_state = "copper";

				desc = "Several handfuls of small, low-value coins."
			}

			silver_coins
			{
				name = "pile of silver coins";
				worth = 15;
				icon = 'valuable.dmi';
				icon_state = "silver";

				desc = "A couple handfuls of valuable silver coins.";
			}

			gold_coins
			{
				name = "pile of gold coins";
				worth = 45;
				icon = 'valuable.dmi';
				icon_state = "gold";

				desc = "A small handful of high-valued gold coins.";
			}
		}

		unusual
		{
			sword
			{
				worth = 15;
				icon = 'equipment.dmi';
				icon_state = "sword";
				attack_adds = 1;
				item_type = "sword";

				durability = 95;

				desc = "A worn but very serviceable sword. This will add 1 to your Attack when equipped.";

				Equip()
					src.WeaponEquip();
			}

			axe
			{
				worth = 15;
				icon = 'equipment.dmi';
				icon_state = "axe";
				attack_adds = 1;
				item_type = "axe";

				durability = 95;

				desc = "A formidable double-headed axe. This will add 1 to your Attack score when equipped.";

				Equip()
					src.WeaponEquip();
			}

			bow
			{
				worth = 20;
				icon = 'equipment.dmi';
				icon_state = "bow";
				attack_adds = 2;
				item_type = "bow";

				durability = 94;

				desc = "A powerful longbow, this will add 2 to your Attack score, but must be reloaded after firing (this occurs automatically and takes 1 turn, during which you won't be able to use the bow's bonus).";

				Equip()
					src.WeaponEquip();
			}

			mace
			{
				worth = 15;
				icon = 'equipment.dmi';
				icon_state = "mace";
				attack_adds = 1;
				item_type = "mace";

				durability = 96;

				desc = "A powerful bludgeon, this will add 1 to your Attack score in battle.";

				Equip()
					src.WeaponEquip();
			}

			spear
			{
				worth = 15;
				icon = 'equipment.dmi';
				icon_state = "spear";
				attack_adds = 1;
				item_type = "spear";

				durability = 93;

				desc = "A well-made spear with a good reach and sharp tip, this will add 1 to your Attack score.";

				Equip()
					src.WeaponEquip();
			}

			whip
			{
				worth = 15;
				icon = 'equipment.dmi';
				icon_state = "whip";
				attack_adds = 1;
				item_type = "whip";

				durability = 97;

				desc = "A whip with a powerful lash that will add 1 to your Attack score.";

				Equip()
					src.WeaponEquip();
			}

			shield
			{
				worth = 15;
				icon = 'equipment.dmi';
				icon_state = "shield";
				block_adds = 40;
				new_block = "deflects";
				item_type = "shield";
				durability = 88;

				desc = "A sturdy shield, this has a chance of deflecting any blows.";

				Equip()
					src.ShieldEquip();
			}

			armor
			{
				worth = 35;
				name = "suit of armor";
				icon = 'equipment.dmi';
				icon_state = "armor";
				defend_adds = 1;
				new_defense = "absorbs";
				item_type = "armor";
				durability = 90;

				desc = "A fine suit of armor, this will absorb 1 point of damage each combat round.";

				Equip()
					src.ArmorEquip();
			}

			healing_potion
			{
				worth = 15;
				icon = 'potions.dmi';
				icon_state = "red";
				item_type = "potion";

				desc = "This bubbling liquid will heal 3 life points when used.";

				Use()
				{
					usr.curlife = min (usr.curlife + 3, usr.life);
					usr.loc.contents - usr << "[usr] drinks a healing potion.";
					usr << "<font color=#C0A0A0</font>A feeling of warmth and well-being flows through your body as you drink the potion.</font>";
					usr.score -= src.worth;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			strength_potion
			{
				name = "strength potion";
				worth = 20;
				icon = 'potions.dmi';
				icon_state = "orange";
				item_type = "potion";

				desc = "This vial of swirling liquid will boost your attack score by 2 for the next combat <i>only</i>.";

				Use()
				{
					usr.adds += 2;
					usr.loc.contents - usr << "[usr] drinks a potion of strength.";
					usr << "<font color=#C0A000>You feel your muscles pulse with power as you drink the potion!</font>";
					usr.score -= src.worth;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			defense_potion
			{
				name = "potion of protection";
				worth = 20;
				icon = 'potions.dmi';
				icon_state = "blue";
				item_type = "potion";

				desc = "This murky potion will absorb 2 hits the next time you take damage <i>only</i>.";

				Use()
				{
					usr.def_adds += 2;
					usr.loc.contents - usr << "[usr] drinks a potion of protection.";
					usr << "<font color=#A000C0>You drink the potion and feel your skin harden and grow tougher.</font>";
					usr.score -= src.worth;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			water
			{
				name = "vial of water";
				worth = 1;
				icon = 'potions.dmi';
				icon_state = "water";
				item_type = "potion";

				desc = "A vial of perfectly ordinary water.";

				Use()
				{
					usr.loc.contents - usr << "[usr] drinks some water.";
					usr << "<font color=#00C0C0>You drink the water. Ah, that hit the spot!</font>";
					usr.score -= src.worth;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			gems
			{
				name = "pile of gems";
				worth = 70;
				icon = 'valuable.dmi';
				icon_state = "gems";

				desc = "Several precious, glittering stones.";
			}

			diamond
			{
				worth = 50;
				icon = 'valuable.dmi';
				icon_state = "diamond";

				desc = "A large diamond, skillfully cut so that it twinkles dazzlingly in the light.";
			}

			silver_chest
			{
				name = "chest of silver";
				worth = 100;
				icon = 'valuable.dmi';
				icon_state = "silver chest";

				desc = "A heavy but valuable chest full of silver coins.";
			}
		}

		rare
		{
			bejewelled_necklace
			{
				worth = 150;
				icon = 'valuable.dmi';
				icon_state = "bejewelled necklace";

				desc = "A finely made piece of jewelry, studded with a dazzling array of diamonds, rubies, and emeralds.";
			}
/*
			speed_potion
			{
				name = "potion of evasion";
				worth = 40;
				icon = 'potions.dmi';
				icon_state = "pink";
				item_type = "potion";

				desc = "This bubbly liquid will give you superhuman agility and allow you to automatically escape the next time you attempt to flee.";

				Use()
				{
					usr.flee = 2;
					usr.loc.contents - usr << "[usr] drinks a potion of evasion.";
					usr << "<font color=#A080A0>You drink the potion and feel lighter and more nimble than ever before.</font>";
					usr.score -= src.worth;
					new/obj/item/vial(usr);
					del(src);
				}
			}
*/
			ring_of_shielding
			{
				worth = 50;
				icon = 'magic.dmi';
				icon_state = "ring of shielding";

				block_adds = 20;

				desc = "Wearing this ring will increase your ability to deflect attacks.";

				Equip()
					src.MiscEquip();
			}

			ring_of_invisibility
			{
				worth = 75;
				icon = 'magic.dmi';
				icon_state = "ring of invisibility";

				desc = "Wearing this ring will let you sneak past monsters unnoticed, but it requires a roll against Lore each turn you use it.";

				constant_use = 1;

				Equip()
					src.MiscEquip();
			}

			ring_of_vampirism
			{
				worth = 100;
				icon = 'magic.dmi';
				icon_state = "ring of vampirism";

				desc = "With this ring on, any time you kill a non-undead opponent, you'll gain 1 life. Using this item successfully requires a Lore roll, however.";

				Equip()
					src.MiscEquip();
			}

			ring_of_warning
			{
				worth = 100;
				icon = 'magic.dmi';
				icon_state = "ring of warning";

				desc = "Wearing this ring will give you a 2/3 chance of avoiding traps.";


				Equip()
					src.MiscEquip();
			}

			amulet_of_protection;
			{
				worth = 90;
				icon = 'magic.dmi';
				icon_state = "amulet of protection";

				constant_use = 1;

				defend_adds = 1;
				new_defense = "absorbs";

				desc = "Wearing this amulet will absorb 1 point of damage you take in combat, but it requires a roll against Lore each turn you use it.";

				Equip()
					src.MiscEquip();
			}

			attack_amulet;
			{
				name = "amulet of strength";
				worth = 90;
				icon = 'magic.dmi';
				icon_state = "amulet of strength";

				constant_use = 1;

				attack_adds = 1;

				desc = "Wearing this amulet will boost your attack power by 1, but requires a roll against Lore for each turn you have it in use.";

				Equip()
					src.MiscEquip();
			}

			charisma_amulet;
			{
				name = "amulet of leadership";
				worth = 90;
				icon = 'magic.dmi';
				icon_state = "amulet of leadership";

				constant_use = 1;

				charisma_adds = 1;

				desc = "Wearing this amulet will boost your charisma by 1, but requires a roll against Lore for each turn you have it in use.";

				Equip()
					src.MiscEquip();
			}

			arcane_robes;
			{
				name = "arcane robes"
				worth = 120;
				icon = 'magic.dmi';
				icon_state = "robes";
				item_type = "armor";

				durability = 100;

				lore_adds = 2;

				desc = "These rune-inscribed robes offer little protection, but will increase your lore by 2.";

				Equip()
					src.ArmorEquip();
			}

			dragonscale_armor;
			{
				worth = 100;
				icon = 'equipment.dmi';
				icon_state = "dragonscale armor";
				item_type = "armor";

				defend_adds = 1;
				new_defense = "absorbs";

				durability = 100;

				desc = "This enchanted suit of armor is forged from the scales of slain dragons, stronger than any steel. It will absorb 1 point of damage each combat round and reduces the devastating effect of dragons' fiery breath.";

				Equip()
					src.ArmorEquip();
			}

			magic_sword;
			{
				worth = 100;
				icon = 'equipment.dmi';
				icon_state = "magic sword";
				item_type = "sword";

				durability = 97;

				attack_adds = 2;

				desc = "This magical sword is much more durable than standard weapons and will add 2 to your attack roll.";

				Equip()
					src.WeaponEquip();
			}


			holy_lance;
			{
				worth = 90;
				icon = 'equipment.dmi';
				icon_state = "holy lance";

				durability = 100;

				attack_adds = 1;

				desc = "This sacred weapon will add 1 to your roll in combat, +1 when fighting undead.";

				Test_Get()
				{
					if (usr.undead)
					{
						usr.loc.contents << "\The [usr] screams as \he burns at the holy lance's touch.";
						return 0;
					}
					else
						return 1;
				}

				Equip()
					src.WeaponEquip();
			}

			farsight_potion
			{
				name = "potion of far-seeing";
				worth = 50;
				icon = 'potions.dmi';
				icon_state = "bronze";
				item_type = "potion";

				desc = "This bronze potion will give you heightened powers of vision, letting you see the contents of the surrounding rooms.";

				Use()
				{
					for (var/dir in dirlist)
					{
						var/ndir;
						switch (dir)
						{
							if (1) ndir = "north";
							if (2) ndir = "south";
							if (4) ndir = "east";
							if (8) ndir = "west";
						}

						var/turf/check = get_step(usr, dir);
						if (check && check.Enter(src))
						{
							if (check.contents.len)
								usr << "<font color=#A06000><B>To the [ndir]</B>, you see...</font>";
							check.Reveal(usr);
						}
					}
					new/obj/item/vial(usr);
					del(src);
				}
			}

			mirror_shield
			{
				worth = 75;
				icon = 'equipment.dmi';
				icon_state = "mirror shield";
				block_adds = 40;
				new_block = "deflects";
				item_type = "shield";
				durability = 95;

				desc = "The shining reflective surface of this shield can deflect deadly gaze attacks.";

				Equip()
					src.ShieldEquip();
			}

			pegasus_wings;
			{
				worth = 100;
				icon = 'magic.dmi';
				icon_state = "pegasus wings";

				desc = "Using the pegasus wings will take you up 1 dungeon level, if you can make a roll on your Lore.";

				Use()
				{
					if (src.Magic_Use(usr))
					{
						if (usr.z == 1)
						{
							if (alert("Are you sure you want to leave the dungeon and cash in all your treasure?", "Confirm Exit", "Yes", "No") == "No")
								return;
							else
							{
								players << "[usr] exits the dungeon with a total score of [usr.score]!";

								for (var/obj/C in src.contents)
								{
									if (C.type == /obj/item/treasure_hoard)
									{
										DoEndGame();
										return;
									}

									C.Move(null);
									usr.contents.Remove(C);

								}

								var/mob/player/N = new();

								var/score/S = new();
								S.owner = usr.name;
								S.total = usr.score;
								scores.Add(S);

								N.key = usr.key;
								N.name = usr.name;

								for (var/image/I in N.cmap)
								{
									del (I);
								}
							}
						}
						else
						{
							usr.loc = locate(usr.x, usr.y, usr.z - 1);
							usr.loc:Reveal(usr);
							usr.loc:RevealAll();
							usr.loc.contents - usr << "<font color=#908080>[usr] suddenly floats up from the floor below, riding on the wings of a pegasus.</font>";
							usr << "<font color=#908080>You feel an odd tingling sensation as the wings magically transport you to the floor above.</font>";
							if (usr.combat || usr.opponent)
							{
								if (usr.opponent)
								{
									usr.opponent.opponent = null;
									usr.opponent.combat = null;
								}
								usr.opponent = null;
								spawn(1) del(usr.combat);
								combats.Remove(usr.combat);
								usr.combat = null;
							}
						}

						usr.score -= src.worth;
						usr << "<font color=#B0A0A0>Their magic spent, the Pegasus Wings fly away into nothingness.</font>";
						del(src);
					}
				}
			}

			gold_chest
			{
				name = "chest of gold";
				worth = 250;
				icon = 'valuable.dmi';
				icon_state = "gold chest";

				desc = "A king's ransom in gold!";
			}

			ghost_potion
			{
				name = "potion of ethereality";
				worth = 30;
				icon = 'potions.dmi';
				icon_state = "purple";
				item_type = "potion";

				desc = "This cloudy potion will give you the ability to become incorporeal and walk through solid walls. Its effects last until you move.";

				Use()
				{
					usr.density = 0;
					usr.loc.contents - usr << "[usr] drinks a potion of ethereality.";
					usr << "<font color=#A0A0A0>You drink the potion and feel your body dissolve into mist.</font>";
					usr.score -= src.worth;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			acid_vial
			{
				name = "vial of acid"
				worth = 35;
				icon = 'potions.dmi';
				icon_state = "green";
				item_type = "potion";

				desc = "This vial is filled with a very potent mixture of acid which, if applied carefully, can eat a hole through solid stone large enough to walk through.";

				Use()
				{
					var/adirlist = list("north", "east", "south", "west", "down");
					var/dir = input("Apply the acid where?", "Acid") in adirlist;
					new/obj/item/vial(usr);
					if (dir == "down")
					{
						if (usr.loc:stairs == "down" || usr.loc:stairs == "both")
						{
							usr << "There's already a perfectly good entrance to the level below!";
							return;
						}
						else if (usr.z == 4)
						{
							usr.loc.contents - usr << "<font color=#80A080>[usr] pours a vial of acid on the ground, and watches disappointed as it fizzles in the solid rock.</font>";
							usr << "<font color=#80A080>You pour the acid on the ground, but it creates only a shallow hole in the solid bedrock.</font>";
							usr.score -= src.worth;
							del(src);
							return;
						}
						else
						{
							usr.loc.contents - usr << "<font color=#80A080>[usr] pours a vial of acid on the ground, eating a hole in the floor large enough to climb through.</font>";
							usr << "<font color=#80A080>You pour the acid on the ground, creating a hole suitable for climbing through.</font>";

							if (usr.loc:stairs == "up")
								usr.loc:stairs = "both";
							else
								usr.loc:stairs = "down";

							var/turf/newloc = locate(usr.x, usr.y, usr.z + 1);
							if (newloc.stairs == "down")
								newloc.stairs = "both";
							else
								newloc.stairs = "up";

							usr.loc:RevealAll();
							newloc:RevealAll();

							newloc.contents << "<font color=#80A080>You hear the fizzle of acid dissolving stone.</font>";

							usr.score -= src.worth;
							del(src);
						}
					}
					else
					{
						var/ndir;
						switch (dir)
						{
							if ("north") ndir = 1;
							if ("south") ndir = 2;
							if ("east") ndir = 4;
							if ("west") ndir = 8;
						}

						var/turf/newloc = get_step(usr, ndir);
						if (!newloc)
						{
							usr.loc.contents - usr << "<font color=#80A080>[usr] carefully pours a vial of acid into a large crack in the [dir] wall, which dissolves away to reveal only solid rock.</font>";
							usr << "<font color=#80A080>You pour the acid into a crack in the [dir] wall, but it dissolves to reveal only solid stone.</font>";
							usr.score -= src.worth;
							del(src);
							return;
						}
						else
						{
							if (usr.loc:exits & ndir)
							{
								usr << "There's already a perfectly good opening there!";
								return;
							}
							else
							{
								usr.loc:exits += ndir;
								newloc.exits += turn(ndir, 180);

								usr.loc.contents - usr << "<font color=#80A080>[usr] pours a vial of acid into a crack in the [dir] wall, eating a large hole into the next room.</font>";
								newloc.contents << "<font color=#80A080>You hear the fizzle of acid dissolving stone.</font>";
								usr << "<font color=#80A080>You pour the acid into a crack in the [dir] wall, creating a gap large enough to walk through.</font>";

								usr.score -= src.worth;
								del(src);

								usr.loc:RevealAll();
								newloc.RevealAll();
							}
						}
					}

				}
			}

			poison_vial
			{
				name = "vial of poison";
				worth = 35;
				icon = 'potions.dmi';
				icon_state = "black";
				item_type = "potion";

				desc = "This lethal venom can be applied to any weapon, even bludgeons. The next 2 times it scores a hit, it will do an additional point of damage.";

				Use()
				{
					if (!usr.weapon)
					{
						usr << "You don't have any weapon to apply the poison to!";
						return;
					}

					if (usr.weapon.poison >= 0) usr.weapon.poison = 2;
					usr << "<font color=#50A050>You carefully apply the poison to your [usr.weapon].</font>";
					usr.score -= src.worth;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			wisdom_potion
			{
				name = "potion of enlightenment";
				worth = 90;
				icon = 'potions.dmi';
				icon_state = "white";
				item_type = "potion";

				desc = "This shimmering potion will increase your Lore skill by 4 for one turn.";

				Use()
				{
					usr.loc.contents - usr << "[usr] drinks a potion of enlightenment.";
					usr << "<font color=#A0B0C0>You drink the potion and feel your knowledge expand with the wisdom of the ancients.</font>";
					usr.score -= src.worth;
					usr.lore_adds += 4;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			accuracy_potion
			{
				name = "potion of accuracy";
				worth = 75;
				icon = 'potions.dmi';
				icon_state = "beige";
				item_type = "potion";

				desc = "This cloudy liquid will guarantee that your next two blows will land.";

				Use()
				{
					usr.loc.contents - usr << "[usr] drinks a potion of accuracy.";
					usr << "<font color=#A0A080>You drink the potion and feel your reflexes and coordination improve.</font>";
					usr.score -= src.worth;
					usr.accuracy = 2;
					new/obj/item/vial(usr);
					del(src);
				}
			}

		}

		legendary
		{
			gem_chest
			{
				name = "chest of gems";
				worth = 600;
				icon = 'valuable.dmi';
				icon_state = "gem chest";

				desc = "An entire chest full of priceless gems!";
			}

			venomblade;
			{
				name = "Venomblade";
				worth = 100;
				icon = 'equipment.dmi';
				icon_state = "venomblade";

				durability = 100;

				attack_adds = 1;
				poison = 15;

				desc = "This lethal dagger is coated with enough poison to last for 15 hits, adding 1 to your attack roll and inflicting an extra point of poison damage while the venom lasts.";

				Equip()
					src.WeaponEquip();
			}

			barbed_whip_of_pain;
			{
				name = "Barbed Whip of Pain";
				worth = 150;
				icon = 'equipment.dmi';
				icon_state = "barbed whip of pain";

				durability = 100;

				attack_adds = 1;

				desc = "This cruelly powerful weapon will add one to your attack score in battle, with a +2 bonus against non-undead opponents.";

				Equip()
					src.WeaponEquip();
			}

			dragonslayer;
			{
				worth = 150;
				icon = 'equipment.dmi';
				icon_state = "dragonslayer";
				item_type = "sword";


				durability = 100;
				attack_adds = 2;

				desc = "This legendary sword was forged for the sole purpose of slaying the ancient dragon Yrendil the Terrible. Its enchanted blade adds 2 to your score in battle, plus it inflicts double damage against dragons.";

				Equip()
					src.WeaponEquip();
			}

			luck_potion
			{
				name = "potion of luck";
				worth = 125;
				icon = 'potions.dmi';
				icon_state = "aqua";
				item_type = "potion";

				desc = "This sparkling liquid will guarantee you a roll of 10 or better on your next combat roll.";

				Use()
				{
					usr.loc.contents - usr << "[usr] drinks a potion of luck.";
					usr << "<font color=#80C080>You drink the potion and feel like you could take on the world!</font>";
					usr.score -= src.worth;
					usr.lucky = 1;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			force_gauntlet;
			{
				name = "gauntlets of force";
				worth = 200;
				icon = 'equipment.dmi';
				icon_state = "gauntlet of force";

				attack_adds = 1;

				desc = "This gem-studded gauntlet will increase your attack score by one for as long as you wear it.";

				Equip()
					src.MiscEquip();
			}

			wizard_staff;
			{
				worth = 150;
				icon = 'equipment.dmi';
				icon_state = "staff of wizardry";

				durability = 100;

				attack_adds = 1;

				desc = "This gnarled cane is enchanted to give +1 to your attack roll, and allows the Magician, Elementalist, and Wizard to cast without restriction while equipped.";

				Magic_Use(mob/P)
				{
					if (..())
					{
						return ..();
					}
					else
						return 0;
				}

				Equip()
					src.WeaponEquip();
			}

			wisdom_ring;
			{
				name = "ring of wisdom";
				worth = 160;
				icon = 'magic.dmi';
				icon_state = "ring of wisdom";

				lore_adds = 1;

				desc = "This azure ring will increase your lore by 1 when you wear it.";

				Equip()
					src.MiscEquip();
			}

			doom_axe
			{
				worth = 150;
				icon = 'equipment.dmi';
				icon_state = "doom axe";
				attack_adds = 1;
				item_type = "axe";

				durability = 100;

				desc = "This golden axe glows with a dark aura. It will add 1 to your attack roll in combat, and ignores all enemy defense.";

				Equip()
					src.WeaponEquip();
			}

			ironskin_potion
			{
				name = "potion of iron skin";
				worth = 150;
				icon = 'potions.dmi';
				icon_state = "grey";
				item_type = "potion";

				desc = "This shining potion will imbue your skin with a magical toughness, permanently raising your defense by 1.";

				Use()
				{
					usr.loc.contents - usr << "[usr] drinks a potion of iron skin.";
					usr << "<font color=#808080>You drink the potion and feel your skin harden like metal.</font>";
					usr.score -= src.worth;
					usr.defend++;
					new/obj/item/vial(usr);
					del(src);
				}
			}

			scry_glass
			{
				name = "scrying glass";
				worth = 250;
				icon = 'magic.dmi';
				icon_state = "scry glass";

				desc = "This small mirror shimmers with the promise of the unseen. A successfull Lore roll will let you see the contents of a room at the x and y coordinates you specify, but it has a chance of breaking even if you succeed.";

				Use()
				{
					if (src.Magic_Use(usr))
					{
						var/x = min(world.maxx, max(1, input("X coordinate?", "Scry") as num));
						var/y = min(world.maxy, max(1, input("Y coordinate?", "Scry") as num));

						var/turf/check = locate(x, y, usr.z);
						usr << "<font color=#00A0A0>You peer into the scrying glass...</font>";
						check.Reveal(usr);
					}
				}

				Magic_Use(mob/M)
				{
					var/roll = roll(2, 6);
					if ((roll - (M.lore + M.lore_adds) > 7 || (rand(1,10) == 1)) && M.class != "Scholar")
					{
						M << "The scrying glass shatters!";
						M.score -= src.worth;
						M.misc_equipped.Remove(src);
						src.TakeAdds();
						spawn(1) del (src);
						return 0;
					}
					else
					{
						return 1;
					}
				}
			}

			ring_of_regeneration
			{
				worth = 120;
				icon = 'magic.dmi';
				icon_state = "ring of regeneration";

				desc = "Wearing this ring will heal 1 health each turn, but requires a roll against Lore to remain effective.";

				constant_use = 1;

				Equip()
					src.MiscEquip();

				Magic_Use(mob/P)
				{
					if (..())
					{
						P.curlife = min(P.curlife + 1, P.life);
					}
				}
			}
		}

		treasure_hoard
		{
			name = "The Legendary Treasure Hoard";
			worth = 2500;
			icon = 'valuable.dmi';
			icon_state = "treasure hoard";

			desc = "An unimaginably huge amount of gold, gems, and priceless jewelry, countless adventurers have tried and failed to find this incredible treasure.";
		}

		vial
		{
			name = "empty vial";
			worth = 0;
			icon = 'potions.dmi';
			icon_state = "empty";

			desc = "An empty glass vial.";
		}

		verb
		{
			get()
			{
				set src in usr.loc;

				for (var/mob/monster/M in usr.loc.contents)
				{
					if (istype(M))
					{
						if (M.type == /mob/monster/guardian)
						{
							usr << "You can't take the Legendary Hoard while the guardian still stands!";
							return;
						}

						if (usr.class != "Thief")
						{
							var/able = 0;

							for (var/mob/companion/C in usr.companions)
							{
								if (C && C.type == /mob/companion/rare/thief)
									able = 1;
							}

							if (able == 0)
							{
								usr << "You can't pick that up while there's a monster guarding it!";
								return 0;
							}
						}
					}
				}

				if (!src.Test_Get())
				{
					return;
				}

				if (usr.class != "Thief")
					usr.loc.contents - usr << "[usr] picks up [src].";

				usr << "You get [src].";

				if (usr.class == "Merchant")
					src.worth = round(src.worth * 1.20, 1);

				src.loc = usr;
				usr.loc:RevealAll();
				usr.score += src.worth;

				src.suffix = "";
				src.equipped = 0;

				if (src.type == /obj/item/treasure_hoard)
				{
					players << "<B>[usr] has found the Legendary Treasure Hoard!</B> The game will end when someone successfully takes the Hoard out of the dungeon, so try to hurry back up to the surface to cash in what you have before it's too late--or track down [usr] and claim the Hoard for yourself!";
				}

				return 1;
			}

			help()
			{
				set src in usr;

				usr << "<B>[src.name] ([src.worth])</B>";
				usr << src.desc;
			}

			drop()
			{
				set src in usr;

				if (src.worth == 0)
				{
					usr.loc.contents << "[usr] discards the worthless [src.name].";
					if (src == usr.weapon) usr.weapon = null;
					if (usr.class == "Swashbuckler" && src == usr:offhand) usr:offhand = null;
					if (src == usr.shield) usr.shield = null;
					if (src == usr.armor) usr.armor = null;
					if (src in usr.misc_equipped) usr.misc_equipped.Remove(src);

					del (src);
				}

				usr.loc.contents << "[usr] drops [src].";

				if (src.equipped == 1)
				{
					src.equipped = 0;
					src.TakeAdds();
				}

				src.loc = usr.loc;
				usr.loc:RevealAll();
				usr.score -= src.worth;

				if (usr.class == "Merchant")
					src.worth = round(src.worth * 5 / 6, 1);

				if (src == usr.weapon) usr.weapon = null;
				if (usr.class == "Swashbuckler" && src == usr:offhand) usr:offhand = null;
				if (src == usr.shield) usr.shield = null;
				if (src == usr.armor) usr.armor = null;
				if (src in usr.misc_equipped) usr.misc_equipped.Remove(src);
			}

			equip()
			{
				set src in usr;

				src.Equip();
			}

			unequip()
			{
				set src in usr;

				src.Remove();
			}

			use()
			{
				set src in usr;
				src.Use();
			}
		}

		proc
		{
			Test_Get()
			{
				return 1;
			}

			GiveAdds()
			{
				var/mob/owner = src.loc;
				if (!ismob(owner))
					return;
				owner.attack += src.attack_adds;
				owner.lore += src.lore_adds;
				owner.defend += src.defend_adds;
				owner.charisma += src.charisma_adds;
				if (src.new_defense) owner.defense = src.new_defense;
				owner.block += src.block_adds;
				if (src.new_block) owner.blocks = src.new_block;
			}

			TakeAdds()
			{
				var/mob/owner = src.loc;
				if (!ismob(owner))
					return;
				owner.attack -= src.attack_adds;
				owner.lore -= src.lore_adds;
				owner.defend -= src.defend_adds;
				owner.charisma -= src.charisma_adds;
				if (owner.defense == src.new_defense) owner.defense = owner.nat_defense;
				owner.block -= src.block_adds;
				if (owner.blocks == src.new_block) owner.blocks = owner.nat_blocks;
			}

			WeaponEquip()
			{
				if (usr.class == "Monk")
				{
					usr << "You're not allowed to wield weapons!";
					return;
				}

				if (usr.class == "Swashbuckler" && usr.weapon)
				{
					usr << "You swap [usr.weapon] to your off-hand and draw [src].";
					if (usr:offhand)
					{
						if (usr:offhand == src)
						{
							usr:offhand = usr.weapon;
							usr.weapon = src;
							return;
						}

						usr:offhand.TakeAdds();
						usr:offhand.equipped = 0;
						usr:offhand.suffix = "";
					}
					usr:offhand = usr.weapon;
					usr.weapon = src;
					src.equipped = 1;
					src.GiveAdds();
				}
				else
				{
					if (usr.weapon)
					{
						usr.weapon.TakeAdds();
						usr.weapon.equipped = 0;
						usr.weapon.suffix = "";
					}
					usr.weapon = src;
					src.equipped = 1;
					src.GiveAdds();

					usr << "You draw [src].";
				}
				src.suffix = "(equipped)";
			}

			ShieldEquip()
			{
				if (usr.class == "Sprite")
				{
					usr << "Woah, that's way too big for you to equip!";
					return;
				}

				if (usr.shield)
				{
					usr.shield.TakeAdds();
					usr.shield.equipped = 0;
					usr.shield.suffix = "";
				}
				usr.shield = src;
				src.equipped = 1;
				src.GiveAdds();
				src.suffix = "(equipped)";

				usr << "You equip [src].";
			}

			ArmorEquip()
			{
				if (usr.class == "Sprite")
				{
					usr << "Woah, that's way too big for you to wear!";
					return;
				}

				if (usr.armor)
				{
					usr.armor.TakeAdds();
					usr.armor.equipped = 0;
					usr.armor.suffix = "";
				}
				usr.armor = src;
				src.equipped = 1;
				src.GiveAdds();
				src.suffix = "(equipped)";

				usr << "You wear [src].";
			}

			MiscEquip()
			{
				if (src in usr.misc_equipped)
				{
					usr << "You're already wearing that!";
					return;
				}

				usr.misc_equipped.Add(src);
				src.equipped = 1;
				src.GiveAdds();
				src.suffix = "(equipped)";

				usr << "You wear [src].";
			}

			Equip()
			{
				usr << "You can't equip that!";
			}

			Use()
			{
				usr << "You can't use that!";
			}

			Magic_Use(mob/M)
			{
				var/roll = roll(2, 6);
				if ((roll - (M.lore + M.lore_adds) > 7 || (rand(1,20) == 1)) && M.class != "Scholar")
				{
					M.loc.contents - M << "\The [M]'s [src] suddenly flickers and stops working.";
					M << "[src] suddenly flickers and fails to function.";
					M.score -= src.worth;
					M.misc_equipped.Remove(src);
					src.TakeAdds();
					spawn(1) del (src);
					return 0;
				}
				else
				{
					return 1;
				}
			}

			Remove()
			{
				if (!src.equipped)
				{
					usr << "You don't have that equipped!";
					return;
				}

				src.suffix = "";

				if (src == usr.weapon)
				{
					src.TakeAdds();
					src.equipped = 0;
					usr.weapon = null;
				}
				else if (src == usr.shield)
				{
					src.TakeAdds();
					src.equipped = 0;
					usr.shield = null;
				}
				else if (src == usr.armor)
				{
					src.TakeAdds();
					src.equipped = 0;
					usr.armor = null;
				}
				else if (usr.class == "Swashbuckler" && src == usr:offhand)
				{
					src.TakeAdds();
					src.equipped = 0;
					usr:offhand = null;
				}
				else if (src in usr.misc_equipped)
				{
					src.TakeAdds();
					src.equipped = 0;
					usr.misc_equipped.Remove(src);
				}
			}
		}
	}
}