var/turf/treasure_room;

/proc
{
	DoGenMap()
	{
		var
		{
			entrances = 9;
			turf/spot;
			x;
			y;
		}

		for (var/i=1, i<=entrances, i++)
		{
			spot = null;
			while (spot == null)
			{
				x = rand (2, world.maxx - 1);
				y = rand (2, world.maxy - 1);

				if (x >= round(world.maxx * 2/5) && x < round(world.maxx * 1/2))
					x = round(x * 4/5);
				else if (x > round(world.maxx * 1/2) && x < round(world.maxx * 3/5, 1))
					x = round(x * 6/5, 1);

				if (y >= round(world.maxy * 2/5) && y < round(world.maxy * 1/2))
					y = round(y * 4/5);
				else if (y > round(world.maxy * 1/2) && y < round(world.maxy * 3/5, 1))
					y = round(y * 6/5, 1);

				spot = locate(x, y, 1);
				if (spot.stairs != null)
					spot = null;
				else
				{
					for (var/dir in dirlist)
					{
						var/turf/check = get_step(spot, dir);
						if (check.stairs != null)
						{
							spot = null;
							break;
						}
					}
				}
			}
			spot.stairs = "up";
			spot.overlays += 'stairup.dmi';
			spot.tag = "entrance[i]";
			spot.icon_state = num2text(spot.exits);
			for (var/dir in dirlist)
			{
				var/turf/check = get_step(spot, dir);
				if (check == null) continue;
				spawn(rand(1, 3)) NextStep(spot, dir);
			}
		}

		spawn(100) DoLevelDown(rand(5,6), 2);
	}

	DoLevelDown(entrances, level)
	{
		var
		{
			turf/spot;
			x;
			y;
		}

		for (var/i=1, i<=entrances, i++)
		{
			spot = null;
			while (spot == null)
			{
				x = rand (1, world.maxx);
				y = rand (1, world.maxy);

				if (x >= round(world.maxx * 2/5) && x < round(world.maxx * 1/2))
					x = round(x * 4/5);
				else if (x > round(world.maxx * 1/2) && x < round(world.maxx * 3/5, 1))
					x = round(x * 6/5, 1);

				if (y >= round(world.maxy * 2/5) && y < round(world.maxy * 1/2))
					y = round(y * 4/5);
				else if (y > round(world.maxy * 1/2) && y < round(world.maxy * 3/5, 1))
					y = round(y * 6/5, 1);

				spot = locate(x, y, level - 1);
				if (spot.stairs != null)
					spot = null;
				else if (spot.exits == null)
					spot = null;

				if (spot && spot.stairs != null)
					spot = null;
				else
				{
					for (var/dir in dirlist)
					{
						var/turf/check = get_step(spot, dir);
						if (check && check.stairs != null)
						{
							spot = null;
							break;
						}
					}
				}
			}
			spot.stairs = "down";
			spot.overlays += 'stairdown.dmi';

			spot = locate(spot.x, spot.y, level);
			spot.stairs = "up";
			spot.overlays += 'stairup.dmi';

			for (var/dir in dirlist)
			{
				spawn(rand(1, 3)) NextStep(spot, dir);
			}
		}

		if (level < 4)
			spawn(70) DoLevelDown(rand(4, 5), level + 1);
		else
			spawn(90) PopulateMap();
	}

	PopulateMap()
	{
		for (var/turf/T in world)
		{
			switch (T.z)
			{
				if (2) T.icon = 'room2.dmi';
				if (3) T.icon = 'room3.dmi';
				if (4) T.icon = 'room4.dmi';
			}

			if (1)
			{
				if (T.z == 1 && T.stairs == "up") continue;

				if (rand(1, 9 + T.z) > 4)
				{
					var/t;
					var/ttt[];

					switch (T.z)
					{
						if (1)
						{
							if (rand(1,6) != 1)
								ttt = typesof(/mob/monster/common);
							else
								ttt = typesof(/mob/monster/unusual);
						}
						if (2)
						{
							if (rand(1,20) < 12)
								ttt = typesof(/mob/monster/unusual);
							else if (rand(1,20) < 17)
								ttt = typesof(/mob/monster/common);
							else
								ttt = typesof(/mob/monster/rare);
						}
						if (3)
						{
							if (rand(1,20) < 15)
								ttt = typesof(/mob/monster/rare);
							else if (rand(1,20) < 20)
								ttt = typesof(/mob/monster/unusual);
							else
								ttt = typesof(/mob/monster/legendary);
						}
						if (4)
						{
							if (rand(1,20) < 14)
								ttt = typesof(/mob/monster/rare);
							else if (rand(1,20) < 17)
								ttt = typesof(/mob/monster/unusual);
							else
								ttt = typesof(/mob/monster/legendary);
						}
					}
					ttt.Remove(/mob/monster, /mob/monster/common, /mob/monster/unusual, /mob/monster/rare, /mob/monster/legendary);

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							new t(T);
							break;
						}
					}
				}
				else if (rand(1,5) == 1)
				{
					var/t;
					var/ttt[];

					switch (T.z)
					{
						if (1)
						{
							if (rand(1,5) != 1)
								ttt = typesof(/mob/companion/common);
							else
								ttt = typesof(/mob/companion/unusual);
						}
						if (2)
						{
							if (rand(1,20) < 12)
								ttt = typesof(/mob/companion/common);
							else if (rand(1,20) < 18)
								ttt = typesof(/mob/companion/unusual);
							else
								ttt = typesof(/mob/companion/rare);
						}
						if (3)
						{
							if (rand(1,20) < 10)
								ttt = typesof(/mob/companion/common);
							else if (rand(1,20) < 15)
								ttt = typesof(/mob/companion/unusual);
							else if (rand(1,20) < 18)
								ttt = typesof(/mob/companion/rare);
							else
								ttt = typesof(/mob/companion/legendary);
						}
						if (4)
						{
							if (rand(1,20) < 12)
								ttt = typesof(/mob/companion/unusual);
							else if (rand(1,20) < 18)
								ttt = typesof(/mob/companion/rare);
							else
								ttt = typesof(/mob/companion/legendary);
						}
					}

					ttt.Remove(/mob/companion, /mob/companion/common, /mob/companion/unusual, /mob/companion/rare, /mob/companion/legendary);

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							new t(T);
							break;
						}
					}
				}

				if (rand(1,20) == 1 && T.stairs == null)
				{
					var/t;
					var/ttt[];

					switch (T.z)
					{
						if (1)
						{
							if (rand(1,20) < 14)
								ttt = typesof(/trap/common);
							else
								ttt = typesof(/trap/unusual);
						}
						if (2)
						{
							if (rand(1,20) < 10)
								ttt = typesof(/trap/common);
							else if (rand(1,20) < 17)
								ttt = typesof(/trap/unusual);
							else
								ttt = typesof(/trap/rare);
						}
						if (3)
						{
							if (rand(1,20) < 7)
								ttt = typesof(/trap/common);
							else if (rand(1,20) < 12)
								ttt = typesof(/trap/unusual);
							else if (rand(1,20) < 17)
								ttt = typesof(/trap/rare);
							else
								ttt = typesof(/trap/legendary);
						}
						if (4)
						{
							if (rand(1,20) < 14)
								ttt = typesof(/trap/unusual);
							else if (rand(1,20) < 16)
								ttt = typesof(/trap/rare);
							else
								ttt = typesof(/trap/legendary);
						}
					}

					ttt.Remove(/trap, /trap/common, /trap/unusual, /trap/rare, /trap/legendary);

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							var/trap/tt = new t();
							T.trap = tt;
							break;
						}
					}
				}
				else if (rand(1,20) == -1 && T.stairs == null)
				{
					var/t;
					var/ttt[];

					switch (T.z)
					{
						if (1)
						{
							if (rand(1,20) < 14)
								ttt = typesof(/special/common);
							else
								ttt = typesof(/special/unusual);
						}
						if (2)
						{
							if (rand(1,20) < 13)
								ttt = typesof(/special/common);
							else if (rand(1,20) < 17)
								ttt = typesof(/special/unusual);
							else
								ttt = typesof(/special/rare);
						}
						if (3)
						{
							if (rand(1,20) < 12)
								ttt = typesof(/special/common);
							else if (rand(1,20) < 12)
								ttt = typesof(/special/unusual);
							else if (rand(1,20) < 17)
								ttt = typesof(/special/rare);
							else
								ttt = typesof(/special/legendary);
						}
						if (4)
						{
							if (rand(1,20) < 14)
								ttt = typesof(/special/unusual);
							else if (rand(1,20) < 16)
								ttt = typesof(/special/rare);
							else
								ttt = typesof(/special/legendary);
						}
					}

					ttt.Remove(/special, /special/common, /special/unusual, /special/rare, /special/legendary);

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							var/special/tt = new t();
							T.special = tt;
							tt.turf = T;
							break;
						}
					}
				}

				var/ismon = 0;

				for (var/atom/A in T.contents)
				{
					if (istype(A, /mob/monster))
						ismon = 1;
				}

				if (rand(1, 3) <= (1 + ismon))
				{
					var/t;
					var/ttt[];

					switch (T.z)
					{
						if (1)
						{
							if (rand(1,5) < 4)
								ttt = typesof(/obj/item/common);
							else
								ttt = typesof(/obj/item/unusual);
						}
						if (2)
						{
							if (rand(1,20) < 10)
								ttt = typesof(/obj/item/common);
							else if (rand(1,20) < 18)
								ttt = typesof(/obj/item/unusual);
							else
								ttt = typesof(/obj/item/rare);
						}
						if (3)
						{
							if (rand(1,20) < 5)
								ttt = typesof(/obj/item/common);
							else if (rand(1,20) < 10)
								ttt = typesof(/obj/item/unusual);
							else if (rand(1,20) < 18)
								ttt = typesof(/obj/item/rare);
							else
								ttt = typesof(/obj/item/legendary);
						}
						if (4)
						{
							if (rand(1,20) < 10)
								ttt = typesof(/obj/item/unusual);
							else if (rand(1,20) < 18)
								ttt = typesof(/obj/item/rare);
							else
								ttt = typesof(/obj/item/legendary);
						}
					}
					ttt.Remove(/obj/item, /obj/item/common, /obj/item/unusual, /obj/item/rare, /obj/item/legendary);

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							new t(T);
							break;
						}
					}
				}
			}

			T.UpdateAppearance();
		}

		var/turf/treasure = null;
		var/turf/check;

		check = locate(7, 8, 2);
		check.stairs = null;
		check = locate(7, 8, 4);
		check.stairs = null;
		treasure = locate(7, 8, 3);
		treasure.icon = 'room5.dmi';
		treasure.stairs = null;
		if (treasure.trap)
			del (treasure.trap);
		treasure.trap = null;
		if (treasure.special)
			del (treasure.special);
		treasure.special = null;
		for (var/atom/A in treasure.contents)
		{
			del (A);
		}
		treasure.UpdateAppearance();
		treasure_room = treasure;
		tguardian = new/mob/monster/guardian(treasure);
		new/obj/item/treasure_hoard(tguardian);
	}

	NextStep(turf/start, dir)
	{
		var/turf/check = get_step(start, dir);

		if (!check) return;

		if (check.exits && !(check.exits & turn(dir, 180)) && rand(0,1)) return;

		if (!(start.exits & dir)) start.exits += dir;
		if (!(check.exits & turn(dir, 180))) check.exits += turn(dir, 180);
		for (var/ndir in dirlist)
		{
			var/turf/ncheck = get_step(check, ndir);
			if (!ncheck || ncheck == start) continue;

			if ((ncheck.exits & turn(ndir,180)) && !(check.exits & ndir))
			{
				check.exits += ndir;
			}
			else if (ncheck.exits == null && rand(1, 10) <= 7)
			{
				spawn(rand(1, 3)) NextStep(check, ndir);
			}
		}

		start.icon_state = num2text(start.exits);
		check.icon_state = num2text(check.exits);
	}
}