/*
MONSTER IDEAS

Legendary- Deep Hydra (0 attack, 5 life--rolls dice equal to its current life)
*/

/mob
{
	monster
	{
		New()
		{
			src.curlife = src.life;
		}

		proc
		{
			Special(mob/V)
			{

			}

			Attack(mob/V)
			{
				src.loc.contents - V << "\The [src] growls and engages [V] in combat!";
				V << "<font color=#A00060>\The [src] growls and attacks you!</font>";
				V.opponent = src;

				var/combat/newcombat = new/combat();
				newcombat.turf = src.loc;
				newcombat.sides.Add(src);
				newcombat.sides.Add(V);
				src.loc:combat = newcombat;
				src.combat = newcombat;
				V.combat = newcombat;
				newcombat.turf.RevealAll();
			}
		}

		common
		{
			giant_bat
			{
				name = "giant bat";
				attack = 1;
				lore = 0;
				life = 1;
				block = 45;
				blocks = "dodges";

				desc = "The bat flutters rapidly about your head, fangs glinting in the torchlight.";
			}

			giant_rat
			{
				name = "giant rat";
				attack = 1;
				lore = 0;
				life = 1;

				desc = "This massive rodent is the size of a dog, and its cruel incisors are crusted with blood and filth.";
			}

			goblin
			{
				name = "goblin";
				attack = 2;
				lore = 1;
				life = 1;
				block = 15;
				blocks = "dodges";

				desc = "The goblin is small, with lean, knotted muscles and a malevolent grin on its face.";
			}

			orc
			{
				name = "orc";
				attack = 2;
				lore = 1;
				life = 2;

				desc = "The orc grunts angrily and looks around for something to hurt.";
			}

			skeleton
			{
				name = "skeleton";
				attack = 1;
				lore = 0;
				life = 2;
				undead = 1;

				desc = "This grim mockery of life makes a dull clattering noise as it walks with a macabre sense of purpose.";
			}

			zombie
			{
				name = "zombie";
				attack = 1;
				lore = 0;
				life = 3;
				undead = 1;

				desc = "This shambling mound of rotten flesh groans wearily with the burdens of undeath.";
			}

			cave_bear
			{
				name = "cave bear";
				attack = 3;
				lore = 1;
				life = 2;

				desc = "The bear issues a low rumble of a growl as it shifts its massive bulk.";
			}

			slime
			{
				name = "slime";
				attack = 1;
				lore = 1;
				life = 1;

				defend = 1;
				defense = "absorbs";

				desc = "The slime's gelatinous mass glistens as it slowly oozes.";
			}

			wolf
			{
				name = "wolf";
				attack = 1;
				lore = 1;
				life = 1;

				desc = "The wolf bares its fangs menacingly as it stares down its prey.";
			}

			bandit
			{
				name = "bandit";
				attack = 2;
				lore = 1;
				life = 1;

				desc = "The bandit skillfully brandishes a pair of gleaming, razor-sharp daggers.";
			}
		}

		unusual
		{
			ogre
			{
				name = "ogre";
				attack = 4;
				lore = 1;
				life = 2;

				desc = "The ogre hefts a massive wooden club, crudely studded with metal debris.";
			}

			troll
			{
				name = "troll";
				attack = 2;
				lore = 3;
				life = 3;

				desc = "The troll's warted, knotted flesh ripples with power belied by its small stature.";
			}

			ghoul
			{
				name = "ghoul";
				attack = 2;
				lore = 0;
				life = 3;
				undead = 1;

				desc = "Bits of flesh cling loosely to this abomination's bones, and its blank eyes nevertheless gaze with a dreadful purpose.";
			}

			drow
			{
				name = "drow warrior";
				attack = 3;
				lore = 3;
				life = 3;

				desc = "This ebon-skinned creature is one of the Drow, the dark counterparts to the merry elves which dwell on the surface. His cold, hard features shine with malice.";
			}

			great_viper
			{
				name = "great viper";
				attack = 2;
				lore = 1;
				life = 1;
				New()
				{
					src.weapon = new/obj/item();
					src.weapon.poison = -1;

					..();
				}

				Die()
				{
					del(src.weapon);

					..();
				}

				desc = "Deadly venom drips from this enormous snake's gleaming fangs.";
			}

			golem
			{
				name = "golem";
				attack = 2;
				lore = 0;
				life = 2;
				defend = 2;
				defense = "is unharmed by";

				desc = "This hulking stone automaton slowly walks about, deprived of all purpose but mindless killing.";
			}

			gremlin
			{
				name = "gremlin";
				attack = 2;
				lore = 1;
				life = 2;

				desc = "This mischeivous creature eyes your valuables eagerly as it scampers about.";

				Special(mob/V)
				{
					var/obj/item/steal;
					var/inventory[] = list();

					for (var/obj/item/I in V.contents)
					{
						if (I && istype(I) && I.equipped == 0)
						{
							inventory.Add(I);
						}
					}

					for (var/i=1, i<=inventory.len, i++)
					{
						if (rand(1, inventory.len + 1 - i) == 1)
						{
							steal = inventory[i];
							src.loc.contents - steal.loc << "Suddenly [src] snatches \a [steal] from [steal.loc]!";
							steal.loc << "Suddenly [src] steals \a [steal] from you!";
							steal.loc = src;
							V.score -= steal.worth;
							if (V.class == "Merchant")
								steal.worth = round(steal.worth * 5 / 6, 1);
							break;
						}
					}
				}
			}

			imp
			{
				name = "imp";
				attack = 1;
				lore = 2;
				life = 1;
				block = 65;
				blocks = "dodges";

				desc = "This small, toothy creature darts to and fro quite rapidly.";
			}

			magician
			{
				name = "magician";
				attack = 1;
				lore = 1;
				life = 2;

				desc = "This dark-robed figure chants magic words ominously.";

				Special(mob/V)
				{
					src.loc.contents - V << "\The [src]'s chanting reaches a feverish pitch as \he conjures forth a swirling fireball!";
					V << "\The [src] raises his voice in chanting and conjures forth a powerful fireball!";

					src.adds += 3;
				}
			}

			wight
			{
				name = "wight";
				attack = 1;
				lore = 1;
				life = 4;
				undead = 1;

				desc = "This pale, ghastly creature wails mournfully as it shuffles about.";
			}
		}

		rare
		{
			great_spider
			{
				name = "great spider";
				attack = 3;
				lore = 1;
				life = 4;

				desc = "This enormous, hairy creature gallops across the dungeon floor on its eight legs, its eyes glowing with malice.";

				Special(mob/V)
				{
					src.loc.contents - V << "Suddenly [src] spins a thick, sticky thread and creates a quick web, pinning [V] where \he stands.";
					V << "Suddenly you find yourself trapped by a heavy, sticky spiderweb!";

					V.flee = -1;
					V.move = V.loc;
					V.adds -= 1;
				}
			}

			mummy
			{
				name = "mummy";
				attack = 3;
				lore = 0;
				life = 7;
				undead = 1;

				desc = "A smell of decay eminates from this dry, slowly rotting corpse, but its withered appearance belies its strength.";
			}

			vampire
			{
				name = "vampire";
				attack = 5;
				lore = 4;
				life = 4;
				undead = 1;

				desc = "This pale, cloaked figure's eyes shine mesmerizingly as he opens his mouth to reveal a pair of long, blood-stained fangs.";
			}

			demon
			{
				name = "demon";
				attack = 6;
				lore = 2;
				life = 3;
				undead = 1;

				desc = "This bat-winged horror grins cruelly at you and opens its double, fang-lined mouths..";
			}

			wyvern
			{
				name = "wyvern";
				attack = 5;
				lore = 1;
				life = 2;

				New()
				{
					src.weapon = new/obj/item();
					src.weapon.poison = -1;

					..();
				}

				Die()
				{
					del(src.weapon);

					..();
				}

				desc = "This leathery-skinned lizard flicks its tail about, its barbed stinger flashing wickedly.";
			}

			sphinx
			{
				name = "sphinx";
				attack = 5;
				lore = 1;
				life = 6;

				desc = "This large, golden creature has the powerful body of a lion, but the face of a human. It looks at you with a deadly sense of a curiosity. Such creatures love riddles and often like to quiz their prey before attacking them.";

				Attack(mob/V)
				{
					src.loc.contents - V << "\The [src] sets [V] a riddle."
					V << "[src] sets you a riddle.";

					var/chance = rand(1,6);
					if (chance != 6 && chance < V.lore + V.lore_adds)
					{
						src.loc.contents - V << "[V] counters correctly, and [src] sulks, deprived of its prey.";
						V << "Having answered correctly, you're left alone by the disappointed sphinx.";
						src.opponent = null;
						V.opponent = null;
					}
					else
					{
						src.loc.contents - V << "[V] can't figure it out, and [src] pounces hungrily!";
						V << "Stumped by the riddle, you brace yourself as [src] pounces!";
						V.opponent = src;

						var/combat/newcombat = new/combat();
						newcombat.turf = src.loc;
						newcombat.sides.Add(src);
						newcombat.sides.Add(V);
						src.loc:combat = newcombat;
						src.combat = newcombat;
						V.combat = newcombat;
						newcombat.turf.RevealAll();
					}
				}
			}

			fire_drake
			{
				name = "fire drake";
				attack = 3;
				lore = 1;
				life = 3;

				desc = "This long, winged serpent's skin glows red with the heat of its breath.";

				Special(mob/V)
				{
					if (V.armor && V.armor.type == /obj/item/rare/dragonscale_armor)
					{
						src.loc.contents - V << "<font color=#907000>\The [src] breathes a jet of searing flame on [V], but \his dragonscale armor resists!</font>";
						V << "<font color=#907000>\The [src] breathes a searing jet of flame, but your dragonscale armor resists!</font>";
					}
					else
					{
						src.loc.contents << "<font color=#C09000>\The [src] opens its mouth, issuing forth a jet of flame!</font>";
						src.adds += 3;
					}

				}
			}

			basilisk
			{
				name = "basilisk";
				attack = 3;
				lore = 1;
				life = 3;

				desc = "This large serpentlike creature gazes about with a tiny grin on its face.";

				Special(mob/V)
				{
					if (rand(1,3) == 1)
					{
						if (!V.shield || V.shield.type != /obj/item/rare/mirror_shield || V.shield.broken == 1)
						{
							src.loc.contents - V << "<font color=#408040>\The [src] narrows its eyes and gazes fiercely at [V], and you watch in horror as [src]'s gaze completely petrifies [V].</font>";
							V << "<font color=#408040>You feel your flesh harden into stone as [src] turns its baleful gaze upon you!</font>";
							V.Die();
						}
						else
						{
							src.loc.contents - V << "<font color=#408080>\The [src] glares at [V] with its deadly gaze, but shrieks with terror as it catches its own image in [V]'s mirror shield and turns itself to stone.</font>";
							V << "<font color=#408080>\The [src] glares at you with its deadly gaze, but shrieks with terror as it catches its own image in your mirror shield and turns itself to stone.</font>";
							src.Die();
						}
					}
				}
			}

			chimera
			{
				name = "chimera";
				attack = 2;
				lore = 1;
				life = 4;

				desc = "This bizarre creature's three heads all eagerly look about for prey.";
			}

			hellhound
			{
				attack = 4;
				lore = 1;
				life = 2;
				undead = 1;

				desc = "This demonic hound's double heads growl in a tone that shakes you to your very soul!.";

				Special(mob/V)
				{
					src.loc.contents << "<font color=#905000>\The [src]'s twin heads let loose a barrage of hellfire!</font>";
					if (V.armor && V.armor.type == /obj/item/rare/dragonscale_armor)
						V << "<font color=#905000>Your dragonscale armor is ineffective against the unholy flame!</font>"

					src.adds += 2;
				}
			}
		}

		legendary
		{
			archfiend
			{
				name = "archfiend";
				attack = 20;
				lore = 2;
				life = 7;
				undead = 1;

				desc = "This enormous abomination flexes his six arms, all bulging with muscles and ending in massive, jagged talons. His gigantic wings beat slowly and silently as his twisted mockery of a face grins at you.";
			}

			shadow
			{
				name = "shadow";
				attack = 4;
				lore = 3;
				life = 3;
				block = 100;
				blocks = "isn't touched by";

				undead = 1;

				desc = "This shadowy apparition has no clearly defined physical form, seeming to be composed of mere darkness. It's difficult to tell where its physical form begins, or indeed if it has a physical form at all.";
			}

			dragon
			{
				name = "dragon";
				attack = 6;
				lore = 1;
				life = 5;

				defend = 2;

				desc = "This massive winged lizard's scales shine like armor, and puffs of flame erupt from its nostrils as it snorts in contempt.";

				Special(mob/V)
				{
					if (V.armor && V.armor.type == /obj/item/rare/dragonscale_armor)
					{
						src.loc.contents - V << "<font color=#A08000>\The [src] lets forth a billowing gale of flaming breath, but [V]'s dragonscale armor resists!</font>";
						V << "<font color=#A08000>\The [src] lets forth a billowing gale of flaming breath, but your dragonscale armor absorbs the bulk of the blast.</font>";
						src.adds += 1;
					}
					else
					{
						src.loc.contents << "<font color=#F0B000>\The [src] suddenly puffs up its chest and emits a fiery gale of breath!</font>";
						src.adds += 4;
					}
				}
			}

			rot_fiend
			{
				name = "rot fiend";
				attack = 5;
				lore = 1;
				life = 3;

				desc = "A hideous mass of decaying compost and corroded debris, the rot fiend leaves acid-burn scars across the stone floor as it shuffles about.";
			}

			banshee
			{
				name = "banshee";
				attack = 1;
				lore = 1;
				life = 6;
				undead = 1;

				desc = "This haunting figure's bare skull has a mournful expression, or at least so far as bones can bare expression.";

				Special(mob/V)
				{
					if (V.undead == 1)
						return;
					src.loc.contents - V << "<font color=#500070>\The [src] lets out a long, unearthly wail, and suddenly [V] drops at its feet.</font>";
					V << "<font color=#500070>\The [src] lets out a long, sorrowful wail, and you feel your soul ripped from your body!</font>";
					V.Die();
				}
			}

			titan
			{
				name = "titan";
				attack = 10;
				lore = 3;
				life = 6;

				desc = "This massive creature's features shine with hatred, its bulging frame throbbing with power.";
			}
		}

		guardian
		{
			name = "eternal guardian";
			attack = 9;
			lore = 7;
			life = 4;

			desc = "This enormous giant's skin is like polished stone, worn smooth over the centuries it has been standing watch over the Legendary Treasure Hoard.";
		}
	}
}