/trap
{
	proc/Triggered(mob/P);

	common
	{
		pitfall
		{
			Triggered(mob/P)
			{
				P.loc.contents - P << "<font color=#808080>[P] falls into a hidden pit trap!</font>";
				spawn(1) P << "<font color=#606060><B>Pit trap! You fall down to level [P.z].</B></font>";

				var/turf/move = locate(P.x, P.y, P.z + 1);

				move.contents << "<font color=#808060>Suddenly a trapdoor opens in the ceiling, and [P] tumbles through.</font>";
				P.loc = move;
				move.RevealAll();
			}
		}
	}

	unusual
	{
		crossbow
		{
			Triggered(mob/P)
			{
				P.loc.contents - P << "<font color=#98A020>A bolt suddenly shoots from a hidden crossbow trap and strikes [P].</font>";
				P << "<font color=#98A050><B>Suddenly a bolt fires from a hidden crossbow trap and hits you!</B></font>";

				P.curlife--;

				if (P.curlife <= 0)
				{
					P.Die();
				}
			}
		}

		alarm
		{
			Triggered(mob/P)
			{
				for (var/mob/M in P.loc.contents)
				{
					if (istype(M, /mob/monster) || istype(M, /mob/companion))
						return;
				}

				var/ttt[] = typesof(/mob/monster/unusual);
				ttt.Remove(/mob/monster/unusual);

				var/t;
				var/mob/tt;

				for (var/i=1, i<=ttt.len, i++)
				{
					if (rand(1, (ttt.len + 1 - i)) == 1)
					{
						t = ttt[i];
						tt = new t(P.loc);
						break;
					}
				}

				P.loc.contents << "<font color=#F00090><B>An alarm sounds as [P] steps on a pressure plate, attracting the attention of \a [tt] wandering nearby!</B></font>";

				P.loc:RevealAll();
			}
		}
	}

	rare
	{
		teleporter
		{
			Triggered(mob/P)
			{
				if (P.class == "Wisp")
				{
					P << "<font color=#006090>You feel the nagging tug of a weak mortal teleportation device but pay it no heed.</font>";
					return;
				}

				P.loc.contents - P << "<font color=#00F0F0>Twinkling lights dance around [P] as \he phases out of existence.</font>";
				P << "<font color=#00F0F0><B>A tingling sensation comes over you as you fade out of existence, only to rematerialize elsewhere.</B></font>";

				P.x = rand(1, world.maxx);
				P.y = rand(1, world.maxy);
				P.z = max(1, min(4, rand(P.z - 1, P.z + 1)));

				P.loc:Reveal(P);
				P.loc:RevealAll();

				P.loc.contents - P << "<font color=#008080>Suddenly [P] materializes from out of nowhere!</font>";
			}
		}

		explosion
		{
			Triggered(mob/P)
			{
				P.loc << "<B><font color=#F0B0000>A fiery explosion erupts from a hidden trap!</B></font>";

				for (var/mob/M in P.loc.contents)
				{
					if (rand(1,3) < 3)
					{
						M.curlife--;

						P.loc << "<font color=#C00000>[M] suffers from the powerful blast!</font>";
					}

					for (var/mob/companion/C in M.companions)
					{
						if (rand(1,4) < 4 && rand(1,100) > C.resist)
						{
							P.loc << "<font color=#C00000>[M]'s companion [C] is killed by the explosion!</font>";

							M.companions.Remove(C);
							del(C);
						}
					}

					if (M.curlife <= 0)
					{
						M.Die();
					}
				}

				P.loc:trap = null;
				del (src);
			}
		}

		cave_in
		{
			Triggered(mob/P)
			{
				P.loc.contents << "<font color=#808080><B>The walls around you quiver and shake as a cascade of rubble pours into the room, drastically altering its structure!</B></font>";

				P.loc:exits = 2 ** rand(0, 3);

				P.loc:RevealAll();

				for (var/dir in dirlist)
				{
					var/turf/check = get_step(P.loc, dir);
					if (check)
					{
						if (P.loc:exits & dir)
						{
							if (!(check.exits & turn(dir, 180)))
							{
								check.exits += turn(dir, 180);
								check.contents << "<font color=#A0A0A0>Suddenly the room shakes, and walls start crumbling around you!</font>";
							}
						}
						else
						{
							if (check.exits & turn(dir, 180))
							{
								check.exits -= turn(dir, 180);
								check.contents << "<font color=#A0A0A0>Suddenly the room shakes, and doors start collapsing!</font>";
							}
						}

						check.RevealAll();
					}
				}

				del (src);
			}
		}
	}

	legendary
	{
		void
		{
			Triggered(mob/P)
			{
				P.loc.contents << "<font color=#404060><B>A swirling black portal of oblivion suddenly enters the room, sucking up the contents!</B></font>";

				for (var/mob/V in P.loc.contents)
				{
					if (istype(V, /mob/player))
					{
						for (var/obj/item/I in V.contents)
						{
							if (rand(1,2) == 2 && I.type != /obj/item/treasure_hoard)
							{
								V << "<font color=#808080>Your [I.name] is sucked into the black void!</font>";
								if (I.equipped == 1)
									I.TakeAdds();
								V.score -= I.worth;
								I.loc = null;
								del(I);
							}
						}
					}
				}
			}
		}
	}
}